-- hds header_start
--
-- VHDL Entity back_end_fpga.address_burst_2.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:06:21 06/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity address_burst_2 is
   port( 
      A_R        : in     std_logic;
      A_W        : in     std_logic;
      CLK        : in     std_logic;
      LOCKED_DCM : in     std_logic;
      RST        : in     std_logic;
      R_BAR      : in     std_logic;
      W_BAR      : in     std_logic;
      Q_A        : out    std_logic
   );

-- Declarations

end address_burst_2 ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.address_burst_2.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:06:33 06/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

library unisim;

architecture struct of address_burst_2 is

   -- Architecture declarations

   -- Internal signal declarations
   signal A_W_fdc : STD_ULOGIC;
   signal Q_int   : STD_ULOGIC;
   signal active  : STD_ULOGIC;
   signal clk_b1  : std_logic;
   signal clk_b2  : std_logic;
   signal high    : std_logic;
   signal low     : std_logic;


   -- Component Declarations
   component OBUFT_HSTL_I
   port (
      I : in     STD_ULOGIC;
      T : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;
   component fdc_1
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component fddrcpe
   port (
      C0  : in     STD_ULOGIC;
      C1  : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D0  : in     STD_ULOGIC;
      D1  : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component inv
   port (
      I : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : OBUFT_HSTL_I use entity unisim.OBUFT_HSTL_I;
   for all : fdc_1 use entity unisim.fdc_1;
   for all : fddrcpe use entity unisim.fddrcpe;
   for all : inv use entity unisim.inv;
   -- exemplar synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   high <= '1';
   low <= '0';

   -- Instance port mappings.
   I5 : OBUFT_HSTL_I
      port map (
         O => Q_A,
         I => Q_int,
         T => low
      );
   I2 : fdc_1
      port map (
         Q   => A_W_fdc,
         C   => CLK,
         CLR => RST,
         D   => A_W
      );
   I3 : fddrcpe
      port map (
         Q   => Q_int,
         C0  => clk_b2,
         C1  => CLK,
         CE  => LOCKED_DCM,
         D0  => A_R,
         D1  => A_W_fdc,
         CLR => RST,
         PRE => low
      );
   I6 : fddrcpe
      port map (
         Q   => active,
         C0  => clk_b1,
         C1  => CLK,
         CE  => high,
         D0  => R_BAR,
         D1  => W_BAR,
         CLR => low,
         PRE => RST
      );
   I4 : inv
      port map (
         O => clk_b1,
         I => CLK
      );
   I7 : inv
      port map (
         O => clk_b2,
         I => CLK
      );

end struct;
