-- hds header_start
--
-- VHDL Entity back_end_fpga.bemod_DDR_conversion.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:54:54 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

entity bemod_DDR_conversion is
   port( 
      FE_enable_reg        : in     std_logic_vector (8 downto 1);
      clk2x                : in     std_logic;
      frm_addr_fifo_empty  : in     std_logic;
      mod1_data            : in     std_logic_vector (3 downto 0);
      mod2_data            : in     std_logic_vector (3 downto 0);
      mod3_data            : in     std_logic_vector (3 downto 0);
      mod4_data            : in     std_logic_vector (3 downto 0);
      mod5_data            : in     std_logic_vector (3 downto 0);
      mod6_data            : in     std_logic_vector (3 downto 0);
      mod7_data            : in     std_logic_vector (3 downto 0);
      mod8_data            : in     std_logic_vector (3 downto 0);
      rdout_sync_out_sig1  : in     std_logic;
      reset                : in     std_logic;
      store_frame_data_bus : in     std_logic_VECTOR (7 downto 0);
      data1                : out    std_logic_vector (7 downto 0);
      data2                : out    std_logic_vector (7 downto 0);
      data3                : out    std_logic_vector (7 downto 0);
      data4                : out    std_logic_vector (7 downto 0);
      data5                : out    std_logic_vector (7 downto 0);
      data6                : out    std_logic_vector (7 downto 0);
      data7                : out    std_logic_vector (7 downto 0);
      data8                : out    std_logic_vector (7 downto 0);
      mux1to8_en           : out    std_logic
   );

-- Declarations

end bemod_DDR_conversion ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.bemod_DDR_conversion.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:55:15 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

library CERC_trig;
library back_end_fpga;
library unisim;

architecture struct of bemod_DDR_conversion is

   -- Architecture declarations

   -- Internal signal declarations
   signal DDR_en1     : std_logic;
   signal DDR_en2     : std_logic;
   signal DDR_en3     : std_logic;
   signal DDR_en4     : std_logic;
   signal DDR_en5     : std_logic;
   signal DDR_en6     : std_logic;
   signal DDR_en7     : std_logic;
   signal DDR_en8     : std_logic;
   signal inputDDR_en : std_logic;


   -- Component Declarations
   component AND2
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component FDC
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component enable_inputDDR
   port (
      FE_enable_reg        : in     std_logic_vector (8 downto 1);
      clk2x                : in     std_logic ;
      frm_addr_fifo_empty  : in     std_logic ;
      rdout_sync_out_sig1  : in     std_logic ;
      reset                : in     std_logic ;
      store_frame_data_bus : in     std_logic_VECTOR (7 downto 0);
      inputDDR_en          : out    std_logic 
   );
   end component;
   component inputDDR
   port (
      clk  : in     std_logic ;
      data : in     std_logic_vector (3 downto 0);
      rst  : in     std_logic ;
      Q    : out    std_logic_vector (7 downto 0);
      ce   : in     std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : AND2 use entity unisim.AND2;
   for all : FDC use entity unisim.FDC;
   for all : enable_inputDDR use entity CERC_trig.enable_inputDDR(fsm);
   for all : inputDDR use entity back_end_fpga.inputDDR(struct_1);
   -- exemplar synthesis_on


begin
   -- Instance port mappings.
   I11 : AND2
      port map (
         O  => DDR_en8,
         I0 => inputDDR_en,
         I1 => FE_enable_reg(8)
      );
   I10 : AND2
      port map (
         O  => DDR_en7,
         I0 => inputDDR_en,
         I1 => FE_enable_reg(7)
      );
   I9 : AND2
      port map (
         O  => DDR_en6,
         I0 => inputDDR_en,
         I1 => FE_enable_reg(6)
      );
   I8 : AND2
      port map (
         O  => DDR_en5,
         I0 => inputDDR_en,
         I1 => FE_enable_reg(5)
      );
   I7 : AND2
      port map (
         O  => DDR_en4,
         I0 => inputDDR_en,
         I1 => FE_enable_reg(4)
      );
   I6 : AND2
      port map (
         O  => DDR_en3,
         I0 => inputDDR_en,
         I1 => FE_enable_reg(3)
      );
   I4 : AND2
      port map (
         O  => DDR_en1,
         I0 => inputDDR_en,
         I1 => FE_enable_reg(1)
      );
   I5 : AND2
      port map (
         O  => DDR_en2,
         I0 => inputDDR_en,
         I1 => FE_enable_reg(2)
      );
   I12 : FDC
      port map (
         Q   => mux1to8_en,
         C   => clk2x,
         CLR => reset,
         D   => inputDDR_en
      );
   I0 : enable_inputDDR
      port map (
         FE_enable_reg        => FE_enable_reg,
         clk2x                => clk2x,
         frm_addr_fifo_empty  => frm_addr_fifo_empty,
         rdout_sync_out_sig1  => rdout_sync_out_sig1,
         reset                => reset,
         store_frame_data_bus => store_frame_data_bus,
         inputDDR_en          => inputDDR_en
      );
   I15 : inputDDR
      port map (
         clk  => clk2x,
         data => mod4_data,
         rst  => reset,
         Q    => data4,
         ce   => DDR_en4
      );
   I19 : inputDDR
      port map (
         clk  => clk2x,
         data => mod8_data,
         rst  => reset,
         Q    => data8,
         ce   => DDR_en8
      );
   I18 : inputDDR
      port map (
         clk  => clk2x,
         data => mod7_data,
         rst  => reset,
         Q    => data7,
         ce   => DDR_en7
      );
   I14 : inputDDR
      port map (
         clk  => clk2x,
         data => mod3_data,
         rst  => reset,
         Q    => data3,
         ce   => DDR_en3
      );
   I13 : inputDDR
      port map (
         clk  => clk2x,
         data => mod2_data,
         rst  => reset,
         Q    => data2,
         ce   => DDR_en2
      );
   I17 : inputDDR
      port map (
         clk  => clk2x,
         data => mod6_data,
         rst  => reset,
         Q    => data6,
         ce   => DDR_en6
      );
   I2 : inputDDR
      port map (
         clk  => clk2x,
         data => mod1_data,
         rst  => reset,
         Q    => data1,
         ce   => DDR_en1
      );
   I16 : inputDDR
      port map (
         clk  => clk2x,
         data => mod5_data,
         rst  => reset,
         Q    => data5,
         ce   => DDR_en5
      );

end struct;
