-- hds header_start
--
-- VHDL Entity back_end_fpga.i2c_lm82.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:56:24 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

entity i2c_lm82 is
   port( 
      i2c_init     : in     std_logic;
      i2c_rst      : in     std_logic;
      iclk40       : in     std_logic;
      lm82_control : in     std_logic_vector (16 downto 0);
      lm82_status  : out    std_logic_vector (15 downto 0);
      scl          : out    std_logic;
      sda          : inout  std_logic
   );

-- Declarations

end i2c_lm82 ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.i2c_lm82.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:56:27 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

library back_end_fpga;
library unisim;

architecture struct of i2c_lm82 is

   -- Architecture declarations
   --attribute no_buff: boolean;
   --attribute noopt: boolean;

   -- Internal signal declarations
   signal ce_i2c          : std_logic;
   signal ce_i2c_rcv      : std_logic;
   signal data_from_lm82  : std_logic_vector(7 downto 0);
   signal data_to_lm82    : std_logic_vector(7 downto 0);
   signal dir_sda         : std_logic;
   signal en_sr_in        : std_logic;
   signal en_sr_out       : std_logic;
   signal i2c_abort       : std_logic;
   signal i2c_busy        : std_logic;
   signal i2c_err         : std_logic;
   signal i2c_rd_nwr      : std_logic;
   signal ipb_low         : std_logic;
   signal ld_sr_out       : std_logic;
   signal lm82_cmnd       : std_logic_vector(7 downto 0);
   signal lm82_ptr_addr   : std_logic_vector(6 downto 0);
   signal pda_out         : std_logic_vector(15 downto 0);
   signal scl_en          : std_logic;
   signal scl_int         : std_logic;
   signal scl_source      : std_logic;
   signal sda_in          : std_logic;
   signal sda_out         : std_logic;
   signal sel_pointer     : std_logic;
   signal set_lm82_status : std_logic;
   signal sr_out          : std_logic;


constant firmware_id: std_logic_vector := "0100";
constant revision_id: std_logic_vector := "00000100";

--attribute no_buff of ds : signal is TRUE;
--attribute noopt of ds : signal is TRUE;

   -- Component Declarations
   component IOBUF
   port (
      I  : in     STD_ULOGIC;
      T  : in     STD_ULOGIC;
      O  : out    STD_ULOGIC;
      IO : inout  STD_ULOGIC
   );
   end component;
   component i2c_clk_gen
   port (
      clk40      : in     std_logic ;
      i2c_rst    : in     std_logic ;
      scl_source : out    std_logic ;
      ce_i2c     : out    std_logic ;
      ce_i2c_rcv : out    std_logic 
   );
   end component;
   component i2c_cntl_lm82
   port (
      ce_i2c          : in     std_logic ;
      data_from_lm82  : in     std_logic_vector (7 downto 0);
      i2c_busy        : in     std_logic ;
      i2c_err         : in     std_logic ;
      i2c_rst         : in     std_logic ;
      iclk40          : in     std_logic ;
      lm82_control    : in     std_logic_vector (16 downto 0);
      set_lm82_status : in     std_logic ;
      data_to_lm82    : out    std_logic_vector (7 downto 0);
      i2c_abort       : out    std_logic ;
      i2c_rd_nwr      : out    std_logic ;
      lm82_cmnd       : out    std_logic_vector (7 downto 0);
      lm82_status     : out    std_logic_vector (15 downto 0)
   );
   end component;
   component i2c_ff
   generic (
      q_rst : std_logic := '0'
   );
   port (
      d   : in     std_logic ;
      clk : in     std_logic ;
      rst : in     std_logic ;
      q   : out    std_logic 
   );
   end component;
   component i2c_lm82_engine
   port (
      ce_i2c          : in     std_logic ;
      ce_i2c_rcv      : in     std_logic ;
      data_to_lm82    : in     std_logic_vector (7 downto 0);
      i2c_abort       : in     std_logic ;
      i2c_init        : in     std_logic ;
      i2c_rd_nwr      : in     std_logic ;
      i2c_rst         : in     std_logic ;
      iclk40          : in     std_logic ;
      lm82_cmnd       : in     std_logic_vector (7 downto 0);
      scl_source      : in     std_logic ;
      sda_in          : in     std_logic ;
      sr_out          : in     std_logic ;
      dir_sda         : out    std_logic ;
      en_sr_in        : out    std_logic ;
      en_sr_out       : out    std_logic ;
      i2c_busy        : out    std_logic ;
      i2c_err         : out    std_logic ;
      ld_sr_out       : out    std_logic ;
      scl_en          : out    std_logic ;
      sda_out         : out    std_logic ;
      sel_pointer     : out    std_logic ;
      set_lm82_status : out    std_logic 
   );
   end component;
   component i2c_lm82_sda_out
   port (
      data_to_lm82  : in     std_logic_vector (7 downto 0);
      i2c_rd_nwr    : in     std_logic ;
      sel_pointer   : in     std_logic ;
      lm82_cmnd     : in     std_logic_vector (7 downto 0);
      lm82_ptr_addr : in     std_logic_vector (6 downto 0);
      pda_out       : out    std_logic_vector (15 downto 0);
      rst           : in     std_logic 
   );
   end component;
   component i2c_sr_input
   port (
      en_sr_in    : in     std_logic ;
      i2c_rst     : in     std_logic ;
      iclk40      : in     std_logic ;
      sda_in      : in     std_logic ;
      i2c_data_in : out    std_logic_vector (7 downto 0)
   );
   end component;
   component i2c_sr_ps
   generic (
      width : integer := 16
   );
   port (
      clk         : in     std_logic ;
      din_para    : in     std_logic_vector (width-1 downto 0);
      din_serial  : in     std_logic ;
      en_shift    : in     std_logic ;
      load_para   : in     std_logic ;
      rst         : in     std_logic ;
      dout_serial : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : IOBUF use entity unisim.IOBUF;
   for all : i2c_clk_gen use entity back_end_fpga.i2c_clk_gen(rtl);
   for all : i2c_cntl_lm82 use entity back_end_fpga.i2c_cntl_lm82(struct);
   for all : i2c_ff use entity back_end_fpga.i2c_ff(rtl);
   for all : i2c_lm82_engine use entity back_end_fpga.i2c_lm82_engine(fsm);
   for all : i2c_lm82_sda_out use entity back_end_fpga.i2c_lm82_sda_out(rtl);
   for all : i2c_sr_input use entity back_end_fpga.i2c_sr_input(rtl);
   for all : i2c_sr_ps use entity back_end_fpga.i2c_sr_ps(rtl);
   -- exemplar synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 3 eb3
   lm82_ptr_addr <= "0011000";
   
   ipb_low <= '0';

   -- HDL Embedded Text Block 7 eb7
   -- eb7 7
   scl_int <= not (scl_en and not scl_source);

   -- Instance port mappings.
   I3 : IOBUF
      port map (
         O  => sda_in,
         IO => sda,
         I  => sda_out,
         T  => dir_sda
      );
   I5 : i2c_clk_gen
      port map (
         clk40      => iclk40,
         i2c_rst    => i2c_rst,
         scl_source => scl_source,
         ce_i2c     => ce_i2c,
         ce_i2c_rcv => ce_i2c_rcv
      );
   I2 : i2c_cntl_lm82
      port map (
         ce_i2c          => ce_i2c,
         data_from_lm82  => data_from_lm82,
         i2c_busy        => i2c_busy,
         i2c_err         => i2c_err,
         i2c_rst         => i2c_rst,
         iclk40          => iclk40,
         lm82_control    => lm82_control,
         set_lm82_status => set_lm82_status,
         data_to_lm82    => data_to_lm82,
         i2c_abort       => i2c_abort,
         i2c_rd_nwr      => i2c_rd_nwr,
         lm82_cmnd       => lm82_cmnd,
         lm82_status     => lm82_status
      );
   I7 : i2c_ff
      generic map (
         q_rst => '1'
      )
      port map (
         d   => scl_int,
         clk => iclk40,
         rst => i2c_rst,
         q   => scl
      );
   I1 : i2c_lm82_engine
      port map (
         ce_i2c          => ce_i2c,
         ce_i2c_rcv      => ce_i2c_rcv,
         data_to_lm82    => data_to_lm82,
         i2c_abort       => i2c_abort,
         i2c_init        => i2c_init,
         i2c_rd_nwr      => i2c_rd_nwr,
         i2c_rst         => i2c_rst,
         iclk40          => iclk40,
         lm82_cmnd       => lm82_cmnd,
         scl_source      => scl_source,
         sda_in          => sda_in,
         sr_out          => sr_out,
         dir_sda         => dir_sda,
         en_sr_in        => en_sr_in,
         en_sr_out       => en_sr_out,
         i2c_busy        => i2c_busy,
         i2c_err         => i2c_err,
         ld_sr_out       => ld_sr_out,
         scl_en          => scl_en,
         sda_out         => sda_out,
         sel_pointer     => sel_pointer,
         set_lm82_status => set_lm82_status
      );
   I0 : i2c_lm82_sda_out
      port map (
         data_to_lm82  => data_to_lm82,
         i2c_rd_nwr    => i2c_rd_nwr,
         sel_pointer   => sel_pointer,
         lm82_cmnd     => lm82_cmnd,
         lm82_ptr_addr => lm82_ptr_addr,
         pda_out       => pda_out,
         rst           => i2c_rst
      );
   I6 : i2c_sr_input
      port map (
         en_sr_in    => en_sr_in,
         i2c_rst     => i2c_rst,
         iclk40      => iclk40,
         sda_in      => sda_in,
         i2c_data_in => data_from_lm82
      );
   I4 : i2c_sr_ps
      generic map (
         width => 16
      )
      port map (
         clk         => iclk40,
         din_para    => pda_out,
         din_serial  => ipb_low,
         en_shift    => en_sr_out,
         load_para   => ld_sr_out,
         rst         => i2c_rst,
         dout_serial => sr_out
      );

end struct;
