-- hds header_start
--
-- VHDL Entity back_end_fpga.i2c_ttc_vme.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:56:19 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

entity i2c_ttc_vme is
   port( 
      TTC_control    : in     std_logic_vector (15 downto 0);
      ce_i2c         : in     std_logic;
      data_from_ttc  : in     std_logic_vector (7 downto 0);
      i2c_busy       : in     std_logic;
      i2c_err        : in     std_logic;
      i2c_rst        : in     std_logic;
      iclk40         : in     std_logic;
      set_vme_status : in     std_logic;
      data_to_ttc    : out    std_logic_vector (7 downto 0);
      i2c_abort      : out    std_logic;
      i2c_rd_nwr     : out    std_logic;
      ttc_pointer    : out    std_logic_vector (4 downto 0);
      ttc_status     : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end i2c_ttc_vme ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.i2c_ttc_vme.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:56:19 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

library back_end_fpga;

architecture struct of i2c_ttc_vme is

   -- Architecture declarations

   -- Internal signal declarations
   signal i2c_err_held  : std_logic;
   signal ipb_high      : std_logic;
   signal rst_status    : std_logic;
   signal ttc_data_held : std_logic_vector(7 downto 0);


   -- Component Declarations
   component i2c_ff_e
   generic (
      q_rst : std_logic := '0'
   );
   port (
      d   : in     std_logic ;
      clk : in     std_logic ;
      rst : in     std_logic ;
      q   : out    std_logic ;
      ce  : in     std_logic 
   );
   end component;
   component i2c_reg_e
   generic (
      width : integer   := 16;
      edge  : std_logic := '1'
   );
   port (
      d   : in     std_logic_vector (width-1 downto 0);
      clk : in     std_logic ;
      rst : in     std_logic ;
      q   : out    std_logic_vector (width-1 downto 0);
      ce  : in     std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : i2c_ff_e use entity back_end_fpga.i2c_ff_e(rtl);
   for all : i2c_reg_e use entity back_end_fpga.i2c_reg_e(rtl);
   -- exemplar synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   -- eb1 1
   ttc_status <= "000000"  
                 & i2c_err_held 
                 & i2c_busy
                 & ttc_data_held;

   -- HDL Embedded Text Block 3 eb3
   -- eb3 3
   ipb_high <= '1';

   -- HDL Embedded Text Block 4 eb4
   -- eb4 4
   i2c_abort <= TTC_control(15);
   rst_status <= TTC_control(15) or i2c_rst;
   -- don't use   TTC_control(14)
   ttc_pointer <= TTC_control(13 downto 9);
   i2c_rd_nwr  <=  TTC_control(8);
   data_to_ttc <= TTC_control(7 downto 0);

   -- Instance port mappings.
   I1 : i2c_ff_e
      generic map (
         q_rst => '0'
      )
      port map (
         d   => ipb_high,
         clk => iclk40,
         rst => rst_status,
         q   => i2c_err_held,
         ce  => i2c_err
      );
   I0 : i2c_reg_e
      generic map (
         width => 8,
         edge  => '1'
      )
      port map (
         d   => data_from_ttc,
         clk => iclk40,
         rst => rst_status,
         q   => ttc_data_held,
         ce  => set_vme_status
      );

end struct;
