-- hds header_start
--
-- VHDL Entity back_end_fpga.qdr_data_read.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:02:25 06/07/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;

entity qdr_data_read is
   port( 
      FE_frame_sync_en        : in     std_logic_vector (8 downto 1);
      FE_trigger              : in     std_logic;
      L1A_bx_count_data       : in     std_logic_vector (35 downto 0);
      be_status_reg           : in     std_logic_vector (31 downto 0);
      clk1x                   : in     std_logic;
      clk2x                   : in     std_logic;
      data_evt_stat           : in     std_logic_vector (7 downto 0);
      data_evt_ty             : in     std_logic_vector (3 downto 0);
      done                    : in     std_logic;
      en_fe_data_capture      : in     std_logic;
      fed_id_reg              : in     std_logic_vector (11 downto 0);
      frm_addr_and_lengths    : in     std_logic_vector (37 downto 0);
      frm_sync_in             : in     std_logic_vector (8 downto 1);
      internal_freeze_bar     : in     std_logic;
      local_reset             : in     std_logic;
      mode_reg                : in     std_logic_vector (3 downto 0);
      qdr_data_in             : in     std_logic_vector (71 downto 0);
      qdr_data_in_en          : in     std_logic;
      rd_fe_lengths           : in     std_logic_vector (17 downto 0);
      rd_total_length_fifo_en : in     std_logic;
      rd_trckr_hdr_en         : in     std_logic;
      start_data_format       : in     std_logic;
      stop_data_format        : in     std_logic;
      ctrl                    : out    std_logic;
      data_out                : out    std_logic_vector (63 downto 0);
      data_out_en             : out    std_logic;
      ready                   : out    std_logic;
      trkr_hdr_25_flag        : out    std_logic;
      trkr_hdr_50_flag        : out    std_logic;
      trkr_hdr_87_flag        : out    std_logic;
      trkr_hdr_fifo_empty     : out    std_logic;
      trkr_hdr_fifo_full      : out    std_logic
   );

-- Declarations

end qdr_data_read ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.qdr_data_read.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:02:41 06/07/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.ALL;

library back_end_fpga;
library unisim;

architecture struct of qdr_data_read is

   -- Architecture declarations

   -- Internal signal declarations
   signal A                        : std_logic_VECTOR(17 downto 0);
   signal B                        : std_logic_VECTOR(17 downto 0);
   signal Q                        : std_logic_VECTOR(17 downto 0);
   signal data_bx_id               : std_logic_vector(11 downto 0);
   signal data_evt_lgth            : std_logic_vector(23 downto 0);
   signal data_in_en               : std_logic;
   signal data_lv1_id              : std_logic_vector(23 downto 0);
   signal int_trkr_hdr             : std_logic_vector(63 downto 0);
   signal qdr_data_mux_en          : std_logic;
   signal rd_total_length_fifo_en1 : std_logic;
   signal read_hdr_en1             : std_logic;
   signal read_hdr_en2             : std_logic;
   signal read_hdr_en3             : std_logic;
   signal ready_int                : std_logic;
   signal reset                    : std_logic;
   signal total_length_fifo_en2    : std_logic;
   signal trckr_hdr_mux_en         : std_logic;
   signal ttc_trkr_hdr             : std_logic_vector(63 downto 0);


   -- ModuleWare signal declarations for instance 'split_1' of 'split'
   signal MW_split_1dinl : std_logic_vector(35 downto 0);

   -- Component Declarations
   component FDC
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component adder_18_bits
   port (
      A    : in     std_logic_VECTOR (17 downto 0);
      B    : in     std_logic_VECTOR (17 downto 0);
      Q    : out    std_logic_VECTOR (17 downto 0);
      CLK  : in     std_logic ;
      CE   : in     std_logic ;
      ACLR : in     std_logic 
   );
   end component;
   component data_format
   generic (
      LENGTH_START : boolean := false
   );
   port (
      clk            : in     std_logic ;
      reset          : in     std_logic ;
      data_bx_id     : in     std_logic_vector (11 downto 0);
      data_evt_lgth  : in     std_logic_vector (23 downto 0);
      data_evt_stat  : in     std_logic_vector (7 downto 0);
      data_evt_ty    : in     std_logic_vector (3 downto 0);
      data_in        : in     std_logic_vector (63 downto 0);
      data_lv1_id    : in     std_logic_vector (23 downto 0);
      data_source_id : in     std_logic_vector (11 downto 0);
      data_in_en     : in     std_logic ;
      start          : in     std_logic ;
      data_out       : out    std_logic_vector (63 downto 0);
      data_out_en    : out    std_logic ;
      ctrl           : out    std_logic ;
      ready          : out    std_logic ;
      stop           : in     std_logic 
   );
   end component;
   component tracker_header
   port (
      FE_frame_sync_en    : in     std_logic_vector (8 downto 1);
      FE_trigger          : in     std_logic ;
      be_status_reg       : in     std_logic_vector (31 downto 0);
      clk1x               : in     std_logic ;
      clk2x               : in     std_logic ;
      done                : in     std_logic ;
      en_fe_data_capture  : in     std_logic ;
      frm_sync_in         : in     std_logic_vector (8 downto 1);
      internal_freeze_bar : in     std_logic ;
      mode_reg            : in     std_logic_vector (3 downto 0);
      rd_fe_lengths       : in     std_logic_vector (17 downto 0);
      read_hdr_en1        : in     std_logic ;
      read_hdr_en2        : in     std_logic ;
      reset               : in     std_logic ;
      int_trkr_hdr        : out    std_logic_vector (63 downto 0);
      trkr_hdr_25_flag    : out    std_logic ;
      trkr_hdr_50_flag    : out    std_logic ;
      trkr_hdr_87_flag    : out    std_logic ;
      trkr_hdr_fifo_empty : out    std_logic ;
      trkr_hdr_fifo_full  : out    std_logic 
   );
   end component;
   component tracker_mux
   port (
      clk2x            : in     std_logic ;
      int_trkr_hdr     : in     std_logic_vector (63 downto 0);
      qdr_data_in      : in     std_logic_vector (71 downto 0);
      qdr_data_mux_en  : in     std_logic ;
      reset            : in     std_logic ;
      trckr_hdr_mux_en : in     std_logic ;
      data_in_en       : out    std_logic ;
      ttc_trkr_hdr     : out    std_logic_vector (63 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : FDC use entity unisim.FDC;
   for all : adder_18_bits use entity back_end_fpga.adder_18_bits(rtl);
   for all : data_format use entity back_end_fpga.data_format(data_format);
   for all : tracker_header use entity back_end_fpga.tracker_header(struct);
   for all : tracker_mux use entity back_end_fpga.tracker_mux(rtl_trkr_mux);
   -- exemplar synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 2 eb2
   A <= frm_addr_and_lengths (17 downto 0);
   B <= "000000000000010000";

   -- HDL Embedded Text Block 3 eb3
   data_evt_lgth <= "000000" & Q ;

   -- HDL Embedded Text Block 4 eb4
   read_hdr_en1 <=
   rd_trckr_hdr_en
   after 1 ns;

   -- HDL Embedded Text Block 5 eb5
   rd_total_length_fifo_en1 <=
   rd_total_length_fifo_en
   after 1 ns;


   -- ModuleWare code for instance 'I11' of 'buff'
   reset <= local_reset;

   -- ModuleWare code for instance 'split_1' of 'split'
   MW_split_1dinl <= L1A_bx_count_data;
   data_bx_id <= MW_split_1dinl(11 downto 0);
   data_lv1_id <= MW_split_1dinl(35 downto 12);
   -- Instance port mappings.
   I1 : FDC
      port map (
         Q   => read_hdr_en2,
         C   => clk2x,
         CLR => reset,
         D   => read_hdr_en1
      );
   I2 : FDC
      port map (
         Q   => qdr_data_mux_en,
         C   => clk2x,
         CLR => reset,
         D   => qdr_data_in_en
      );
   I5 : FDC
      port map (
         Q   => total_length_fifo_en2,
         C   => clk2x,
         CLR => reset,
         D   => rd_total_length_fifo_en1
      );
   I8 : FDC
      port map (
         Q   => trckr_hdr_mux_en,
         C   => clk2x,
         CLR => reset,
         D   => read_hdr_en3
      );
   I7 : FDC
      port map (
         Q   => read_hdr_en3,
         C   => clk2x,
         CLR => reset,
         D   => read_hdr_en2
      );
   I9 : FDC
      port map (
         Q   => ready,
         C   => clk2x,
         CLR => reset,
         D   => ready_int
      );
   I4 : adder_18_bits
      port map (
         A    => A,
         B    => B,
         Q    => Q,
         CLK  => clk2x,
         CE   => total_length_fifo_en2,
         ACLR => reset
      );
   data_format_1 : data_format
      generic map (
         LENGTH_START => false
      )
      port map (
         clk            => clk2x,
         reset          => reset,
         data_bx_id     => data_bx_id,
         data_evt_lgth  => data_evt_lgth,
         data_evt_stat  => data_evt_stat,
         data_evt_ty    => data_evt_ty,
         data_in        => ttc_trkr_hdr,
         data_lv1_id    => data_lv1_id,
         data_source_id => fed_id_reg,
         data_in_en     => data_in_en,
         start          => start_data_format,
         data_out       => data_out,
         data_out_en    => data_out_en,
         ctrl           => ctrl,
         ready          => ready_int,
         stop           => stop_data_format
      );
   tracker_header_1 : tracker_header
      port map (
         FE_frame_sync_en    => FE_frame_sync_en,
         FE_trigger          => FE_trigger,
         be_status_reg       => be_status_reg,
         clk1x               => clk1x,
         clk2x               => clk2x,
         done                => done,
         en_fe_data_capture  => en_fe_data_capture,
         frm_sync_in         => frm_sync_in,
         internal_freeze_bar => internal_freeze_bar,
         mode_reg            => mode_reg,
         rd_fe_lengths       => rd_fe_lengths,
         read_hdr_en1        => read_hdr_en1,
         read_hdr_en2        => read_hdr_en2,
         reset               => reset,
         int_trkr_hdr        => int_trkr_hdr,
         trkr_hdr_25_flag    => trkr_hdr_25_flag,
         trkr_hdr_50_flag    => trkr_hdr_50_flag,
         trkr_hdr_87_flag    => trkr_hdr_87_flag,
         trkr_hdr_fifo_empty => trkr_hdr_fifo_empty,
         trkr_hdr_fifo_full  => trkr_hdr_fifo_full
      );
   tracker_mux_1 : tracker_mux
      port map (
         clk2x            => clk2x,
         int_trkr_hdr     => int_trkr_hdr,
         qdr_data_in      => qdr_data_in,
         qdr_data_mux_en  => qdr_data_mux_en,
         reset            => reset,
         trckr_hdr_mux_en => trckr_hdr_mux_en,
         data_in_en       => data_in_en,
         ttc_trkr_hdr     => ttc_trkr_hdr
      );

end struct;
