-- hds header_start
--
-- VHDL Entity back_end_fpga.qdr_sram_interface.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:06:33 06/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;

entity qdr_sram_interface is
   port( 
      clk2x               : in     std_logic;
      fe_data             : in     std_logic_vector (63 downto 0);
      internal_freeze_bar : in     std_logic;
      local_reset         : in     std_logic;
      locked_all_clks     : in     std_logic;
      qdr_1_q             : in     std_logic_vector (17 downto 0);
      qdr_2_q             : in     std_logic_vector (17 downto 0);
      qdr_rd_addr         : in     std_logic_vector (20 downto 1);
      qdr_rd_addr_en      : in     std_logic;
      qdr_test_data_en    : in     std_logic_vector (1 downto 0);
      qdr_wr_addr         : in     std_logic_vector (20 downto 1);
      qdr_wr_addr_en      : in     std_logic;
      qdr_addr            : out    std_logic_vector (20 downto 1);
      qdr_bw_n            : out    std_logic_vector (1 downto 0);
      qdr_data_in         : out    std_logic_vector (71 downto 0);
      qdr_data_in_en      : out    std_logic;
      qdr_read_b          : out    std_logic;
      qdr_write_b         : out    std_logic;
      wr_data_qdr1_lsb    : out    std_logic_vector (17 downto 0);
      wr_data_qdr2_msb    : out    std_logic_vector (17 downto 0)
   );

-- Declarations

end qdr_sram_interface ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.qdr_sram_interface.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:07:07 06/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

library back_end_fpga;
library unisim;

architecture struct of qdr_sram_interface is

   -- Architecture declarations

   -- Internal signal declarations
   signal O1                : STD_ULOGIC;
   signal O2                : STD_ULOGIC;
   signal low               : STD_ULOGIC;
   signal qdr1_data_lsb     : std_logic_vector(35 downto 0);
   signal qdr2_data_msb     : std_logic_vector(35 downto 0);
   signal qdr_FE_data       : std_logic_vector(71 downto 0);
   signal qdr_bw_int        : std_logic_vector(1 downto 0);
   signal qdr_count_data    : std_logic_vector(71 downto 0);
   signal qdr_data          : std_logic_vector(35 downto 0);    -- 36-bit data to be written to two QDR memories
   signal qdr_data1_lsb     : std_logic_vector(35 downto 0);
   signal qdr_data1_msb     : std_logic_vector(35 downto 0);
   signal qdr_data_in_en1   : std_logic;
   signal qdr_data_in_en2   : std_logic;
   signal qdr_in_data       : std_logic_vector(35 downto 0);
   signal qdr_read_b_int    : std_logic;
   signal qdr_test_pattern  : std_logic_vector(71 downto 0);
   signal qdr_wr_addr_1     : std_logic_vector(20 downto 1);    -- QDR write address
   signal qdr_wr_addr_en_1  : std_logic;
   signal qdr_wr_data       : std_logic_vector(71 downto 0);
   signal qdr_write_b_int   : std_logic;
   signal qdr_write_b_int1  : std_logic;
   signal qdr_write_b_int2  : std_logic;
   signal qdr_write_b_int_1 : std_logic;
   signal reset             : std_logic;


   -- ModuleWare signal declarations for instance 'I0' of 'split'
   signal MW_I0dinl : std_logic_vector(71 downto 0);

   -- ModuleWare signal declarations for instance 'I4' of 'split'
   signal MW_I4dinl : std_logic_vector(35 downto 0);

   -- Component Declarations
   component FDC
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component FDCP
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component NAND2
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component address_burst_2
   port (
      A_R        : in     std_logic ;
      A_W        : in     std_logic ;
      CLK        : in     std_logic ;
      LOCKED_DCM : in     std_logic ;
      RST        : in     std_logic ;
      R_BAR      : in     std_logic ;
      W_BAR      : in     std_logic ;
      Q_A        : out    std_logic 
   );
   end component;
   component data_mux
   port (
      clk2x            : in     std_logic ;
      qdr_FE_data      : in     std_logic_vector (71 downto 0);
      qdr_count_data   : in     std_logic_vector (71 downto 0);
      qdr_test_data_en : in     std_logic_vector (1 downto 0);
      qdr_test_pattern : in     std_logic_vector (71 downto 0);
      reset            : in     std_logic ;
      qdr_wr_data      : out    std_logic_vector (71 downto 0)
   );
   end component;
   component fddrrse
   port (
      C0 : in     STD_ULOGIC;
      C1 : in     STD_ULOGIC;
      CE : in     STD_ULOGIC;
      D0 : in     STD_ULOGIC;
      D1 : in     STD_ULOGIC;
      R  : in     STD_ULOGIC;
      S  : in     STD_ULOGIC;
      Q  : out    STD_ULOGIC
   );
   end component;
   component inv
   port (
      I : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;
   component rd_burst_2
   port (
      D     : in     std_logic ;
      EN    : in     std_logic ;
      clk_c : in     std_logic ;
      clk_k : in     std_logic ;
      rst   : in     std_logic ;
      Q0    : out    std_logic ;
      Q1    : out    std_logic 
   );
   end component;
   component tst_data_gen
   port (
      clk2x            : in     std_logic ;
      qdr_test_data_en : in     std_logic_vector (1 downto 0);
      qdr_wr_addr_en_1 : in     std_logic ;
      reset            : in     std_logic ;
      qdr_test_pattern : out    std_logic_vector (71 downto 0)
   );
   end component;
   component wr_burst_2
   port (
      D0         : in     std_logic ;
      D1         : in     std_logic ;
      DCM_locked : in     std_ulogic ;
      clk        : in     std_logic ;
      rst        : in     std_logic ;
      wr         : in     std_logic ;
      Q          : out    std_logic 
   );
   end component;

   -- ModuleWare Component Declarations
   component adff_385617B9
   port (
      Clk : in     std_logic;
      D   : in     std_logic_vector (1 downto 0);
      Rst : in     std_logic;
      Q   : out    std_logic_vector (1 downto 0);
      Qb  : out    std_logic_vector (1 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : FDC use entity unisim.FDC;
   for all : FDCP use entity unisim.FDCP;
   for all : NAND2 use entity unisim.NAND2;
   for all : address_burst_2 use entity back_end_fpga.address_burst_2(struct);
   for all : data_mux use entity back_end_fpga.data_mux(rtl);
   for all : fddrrse use entity unisim.fddrrse;
   for all : inv use entity unisim.inv;
   for all : rd_burst_2 use entity back_end_fpga.rd_burst_2(DDR_same_clk);
   for all : tst_data_gen use entity back_end_fpga.tst_data_gen(fsm);
   for all : wr_burst_2 use entity back_end_fpga.wr_burst_2(struct);
   -- exemplar synthesis_on

   -- ModuleWare embedded configurations
   -- exemplar synthesis_off
   for all : adff_385617B9 use entity back_end_fpga.adff_385617B9;
   -- exemplar synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   -- make data into 72-bit word
   
   qdr_FE_data <= ("10101010" & fe_data);
   
   qdr_count_data <= ("1010" 
                                  & "10101010000000" & qdr_wr_addr
                                  & "10101010000000" & qdr_wr_addr );

   -- HDL Embedded Text Block 2 eb2
   -- assign Byte Write bits active low
   qdr_bw_int <= "00";

   -- HDL Embedded Text Block 3 eb3
   qdr_data_in <= qdr2_data_msb & 
   qdr1_data_lsb after 1 ns;


   -- ModuleWare code for instance 'I0' of 'split'
   MW_I0dinl <= qdr_wr_data;
   qdr_data1_lsb <= MW_I0dinl(35 downto 0);
   qdr_data1_msb <= MW_I0dinl(71 downto 36);

   -- ModuleWare code for instance 'I4' of 'split'
   MW_I4dinl <= qdr_data;
   wr_data_qdr1_lsb <= MW_I4dinl(17 downto 0);
   wr_data_qdr2_msb <= MW_I4dinl(35 downto 18);

   -- ModuleWare code for instance 'I8' of 'merge'
   qdr_in_data <= qdr_2_q & qdr_1_q;

   -- ModuleWare code for instance 'I1' of 'inv'
      qdr_read_b_int <= not(qdr_rd_addr_en);

   -- ModuleWare code for instance 'I2' of 'gnd'
      low <= '0';

   -- ModuleWare code for instance 'I22' of 'buff'
   reset <= local_reset;
   -- Instance port mappings.
   I9 : FDC
      port map (
         Q   => qdr_data_in_en2,
         C   => clk2x,
         CLR => reset,
         D   => qdr_data_in_en1
      );
   I12 : FDC
      port map (
         Q   => qdr_data_in_en,
         C   => clk2x,
         CLR => reset,
         D   => qdr_data_in_en2
      );
   I6 : FDC
      port map (
         Q   => qdr_data_in_en1,
         C   => clk2x,
         CLR => reset,
         D   => qdr_rd_addr_en
      );
   I24 : FDCP
      port map (
         Q   => qdr_write_b_int_1,
         C   => clk2x,
         CLR => low,
         D   => qdr_write_b_int,
         PRE => reset
      );
   I23 : FDCP
      port map (
         Q   => qdr_write_b_int2,
         C   => clk2x,
         CLR => low,
         D   => qdr_write_b_int1,
         PRE => reset
      );
   I18 : FDCP
      port map (
         Q   => qdr_write_b_int1,
         C   => clk2x,
         CLR => low,
         D   => qdr_wr_addr_en_1,
         PRE => reset
      );
   I11 : FDCP
      port map (
         Q   => qdr_write_b_int,
         C   => clk2x,
         CLR => low,
         D   => qdr_wr_addr_en_1,
         PRE => reset
      );
   I13 : NAND2
      port map (
         O  => qdr_wr_addr_en_1,
         I0 => internal_freeze_bar,
         I1 => qdr_wr_addr_en
      );
   data_mux_1 : data_mux
      port map (
         clk2x            => clk2x,
         qdr_FE_data      => qdr_FE_data,
         qdr_count_data   => qdr_count_data,
         qdr_test_data_en => qdr_test_data_en,
         qdr_test_pattern => qdr_test_pattern,
         reset            => reset,
         qdr_wr_data      => qdr_wr_data
      );
   I17 : fddrrse
      port map (
         Q  => qdr_read_b,
         D0 => qdr_read_b_int,
         D1 => qdr_read_b_int,
         C0 => clk2x,
         C1 => O1,
         CE => locked_all_clks,
         S  => reset,
         R  => low
      );
   I14 : fddrrse
      port map (
         Q  => qdr_write_b,
         D0 => qdr_write_b_int_1,
         D1 => qdr_write_b_int_1,
         C0 => clk2x,
         C1 => O2,
         CE => locked_all_clks,
         S  => reset,
         R  => low
      );
   I16 : inv
      port map (
         O => O1,
         I => clk2x
      );
   I15 : inv
      port map (
         O => O2,
         I => clk2x
      );
   tst_data_gen_1 : tst_data_gen
      port map (
         clk2x            => clk2x,
         qdr_test_data_en => qdr_test_data_en,
         qdr_wr_addr_en_1 => qdr_wr_addr_en_1,
         reset            => reset,
         qdr_test_pattern => qdr_test_pattern
      );

   -- ModuleWare instance port mappings.
   I5 : adff_385617B9
      port map (
         Clk => clk2x,
         D   => qdr_bw_int,
         Rst => reset,
         Q   => qdr_bw_n,
         Qb  => open
      );


   g0: FOR i IN 0 TO 35 GENERATE
      rd_burst_2_1 : rd_burst_2
         port map (
            D     => qdr_in_data(i),
            EN    => qdr_data_in_en2,
            clk_c => clk2x,
            clk_k => clk2x,
            rst   => reset,
            Q0    => qdr2_data_msb(i),
            Q1    => qdr1_data_lsb(i)
         );
   end generate g0;

   g1: FOR i IN 1 TO 20 GENERATE
      address_burst_2_1 : address_burst_2
         port map (
            A_R        => qdr_rd_addr(i),
            A_W        => qdr_wr_addr_1(i),
            CLK        => clk2x,
            LOCKED_DCM => locked_all_clks,
            RST        => reset,
            R_BAR      => qdr_read_b_int,
            W_BAR      => qdr_write_b_int_1,
            Q_A        => qdr_addr(i)
         );
   end generate g1;

   g2: FOR i IN 0 TO 35 GENERATE
      wr_burst_2_1 : wr_burst_2
         port map (
            D0         => qdr_data1_lsb(i),
            D1         => qdr_data1_msb(i),
            DCM_locked => locked_all_clks,
            clk        => clk2x,
            rst        => reset,
            wr         => qdr_write_b_int2,
            Q          => qdr_data(i)
         );
   end generate g2;

   g3: FOR i IN 1 TO 20 GENERATE
      I21 : FDC
         port map (
            Q   => qdr_wr_addr_1(i),
            C   => clk2x,
            CLR => reset,
            D   => qdr_wr_addr(i)
         );
   end generate g3;

end struct;
