-- hds header_start
--
-- VHDL Entity back_end_fpga.rd_addr_sr.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:15:24 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.ALL;

entity rd_addr_sr is
   port( 
      back_pressure_B      : in     std_logic;
      clk2x                : in     std_logic;
      frm_addr_and_lengths : in     std_logic_vector (37 downto 0);
      rd_load_or_count     : in     std_logic;
      reset                : in     std_logic;
      qdr_rd_addr          : out    std_logic_vector (20 downto 1);
      qdr_rd_addr_en       : out    std_logic;
      rd_length_1          : out    std_logic_vector (17 downto 0)
   );

-- Declarations

end rd_addr_sr ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.rd_addr_sr.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:15:27 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

library back_end_fpga;
library marc_calice;
library unisim;

architecture struct of rd_addr_sr is

   -- Architecture declarations

   -- Internal signal declarations
   signal rd_base_1       : std_logic_VECTOR(19 downto 0);
   signal rd_base_addr    : std_logic_vector(19 downto 0);
   signal rd_base_int     : std_logic_VECTOR(19 downto 0);
   signal rd_frm_data_1   : STD_ULOGIC;
   signal rd_length_2     : std_logic_vector(17 downto 0);
   signal rd_length_int   : std_logic_vector(17 downto 0);
   signal rd_total_length : std_logic_vector(17 downto 0);

   -- Implicit buffer signal declarations
   signal rd_length_1_internal : std_logic_vector (17 downto 0);


   -- ModuleWare signal declarations for instance 'I6' of 'split'
   signal MW_I6dinl : std_logic_vector(37 downto 0);

   -- Component Declarations
   component dff_18_bits
   port (
      D    : in     std_logic_VECTOR (17 downto 0);
      Q    : out    std_logic_VECTOR (17 downto 0);
      CLK  : in     std_logic ;
      CE   : in     std_logic ;
      ACLR : in     std_logic 
   );
   end component;
   component dff_20_bits
   port (
      D    : in     std_logic_vector (19 downto 0);
      Q    : out    std_logic_vector (19 downto 0);
      CLK  : in     std_logic ;
      CE   : in     std_logic ;
      ACLR : in     std_logic 
   );
   end component;
   component fdc
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component rd_add_one
   port (
      clk2x            : in     std_logic ;
      rd_base_addr     : in     std_logic_vector (19 downto 0);
      rd_base_int      : in     std_logic_VECTOR (19 downto 0);
      rd_frm_data_1    : in     STD_ULOGIC ;
      rd_load_or_count : in     std_logic ;
      reset            : in     std_logic ;
      rd_base_1        : out    std_logic_VECTOR (19 downto 0)
   );
   end component;
   component rd_decrement_one
   port (
      back_pressure_B  : in     std_logic ;
      clk2x            : in     std_logic ;
      rd_length_int    : in     std_logic_vector (17 downto 0);
      rd_load_or_count : in     std_logic ;
      rd_total_length  : in     std_logic_vector (17 downto 0);
      reset            : in     std_logic ;
      rd_frm_data_1    : out    STD_ULOGIC ;
      rd_length_1      : out    std_logic_vector (17 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : dff_18_bits use entity back_end_fpga.dff_18_bits(rtl);
   for all : dff_20_bits use entity marc_calice.dff_20_bits(rtl);
   for all : fdc use entity unisim.fdc;
   for all : rd_add_one use entity back_end_fpga.rd_add_one(rtl_rd_throttle);
   for all : rd_decrement_one use entity back_end_fpga.rd_decrement_one(rtl_bak_pressure);
   -- exemplar synthesis_on


begin

   -- ModuleWare code for instance 'I6' of 'split'
   MW_I6dinl <= frm_addr_and_lengths;
   rd_total_length <= MW_I6dinl(17 downto 0);
   rd_base_addr <= MW_I6dinl(37 downto 18);

   -- ModuleWare code for instance 'I0' of 'buff'
   rd_length_int <= rd_length_1_internal;

   -- ModuleWare code for instance 'I1' of 'buff'
   rd_base_int <= rd_base_1;
   -- Instance port mappings.
   I4 : dff_18_bits
      port map (
         D    => rd_length_1_internal,
         Q    => rd_length_2,
         CLK  => clk2x,
         CE   => rd_frm_data_1,
         ACLR => reset
      );
   I8 : dff_20_bits
      port map (
         D    => rd_base_1,
         Q    => qdr_rd_addr,
         CLK  => clk2x,
         CE   => rd_frm_data_1,
         ACLR => reset
      );
   I7 : fdc
      port map (
         Q   => qdr_rd_addr_en,
         C   => clk2x,
         CLR => reset,
         D   => rd_frm_data_1
      );
   I3 : rd_add_one
      port map (
         clk2x            => clk2x,
         rd_base_addr     => rd_base_addr,
         rd_base_int      => rd_base_int,
         rd_frm_data_1    => rd_frm_data_1,
         rd_load_or_count => rd_load_or_count,
         reset            => reset,
         rd_base_1        => rd_base_1
      );
   I2 : rd_decrement_one
      port map (
         back_pressure_B  => back_pressure_B,
         clk2x            => clk2x,
         rd_length_int    => rd_length_int,
         rd_load_or_count => rd_load_or_count,
         rd_total_length  => rd_total_length,
         reset            => reset,
         rd_frm_data_1    => rd_frm_data_1,
         rd_length_1      => rd_length_1_internal
      );

   -- Implicit buffered output assignments
   rd_length_1 <= rd_length_1_internal;

end struct;
