-- hds header_start
--
-- VHDL Entity back_end_fpga.top_level.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:07:29 06/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity top_level is
   port( 
      clk_lvds_vme         : in     std_logic;
      clk_lvds_vme_b       : in     std_logic;
      fe_config_out        : in     std_logic_vector (8 downto 1);
      fe_empty_flag        : in     std_logic;
      fe_frame_sync_out    : in     std_logic_vector (8 downto 1);
      fe_full_flag         : in     std_logic;
      fe_half_flag         : in     std_logic;
      fe_readout_sync_out  : in     std_logic_vector (8 downto 1);
      frame_sync_trig_i    : in     std_logic;
      local_vme_read       : in     std_logic;
      local_vme_write      : in     std_logic;
      mod1_data            : in     std_logic_vector (3 downto 0);
      mod2_data            : in     std_logic_vector (3 downto 0);
      mod3_data            : in     std_logic_vector (3 downto 0);
      mod4_data            : in     std_logic_vector (3 downto 0);
      mod5_data            : in     std_logic_vector (3 downto 0);
      mod6_data            : in     std_logic_vector (3 downto 0);
      mod7_data            : in     std_logic_vector (3 downto 0);
      mod8_data            : in     std_logic_vector (3 downto 0);
      qdr_1_q              : in     std_logic_vector (17 downto 0);
      qdr_2_q              : in     std_logic_vector (17 downto 0);
      readout_sync_trig_i  : in     std_logic;
      rst                  : in     std_logic;
      temp_int_b           : in     std_logic;
      test_trig            : in     std_logic;
      test_trig_B          : in     std_logic;
      trig_data1           : in     std_logic_vector (7 downto 0);
      trig_ser_in          : in     std_logic;
      trigger_i            : in     std_logic;
      trigger_raw_i        : in     std_logic;
      vme_command_in       : in     std_logic;
      vme_spare_in         : in     std_logic_vector (5 downto 1);
      vme_throttle         : in     std_logic;
      BE_LED               : out    std_logic;
      FE_lvds_clk          : out    std_logic_vector (8 downto 1);
      FE_lvds_clk_B        : out    std_logic_vector (8 downto 1);
      be_locked_all_clks_o : out    std_logic;
      clk1x_o              : out    std_logic;
      clk2x_o              : out    std_logic;
      cntl_to_vme          : out    std_logic;
      crate_trig_in_en_o   : out    std_logic;
      crate_trig_loop_en_o : out    std_logic;
      data_out_to_vme      : out    std_logic_vector (31 downto 0);
      data_to_vme_valid    : out    std_logic;
      ext_qdr_clk_c        : out    std_logic;
      ext_qdr_clk_c_bar    : out    std_logic;
      fe_config_in         : out    std_logic_vector (8 downto 1);
      fe_monitor_in        : out    std_logic_vector (8 downto 1);
      fe_readout_sync_in   : out    std_logic_vector (8 downto 1);
      fe_trig_en_o         : out    std_logic_vector (7 downto 0);
      led_run_process      : out    std_logic;
      lm82_scl             : out    std_logic;
      qdr_addr             : out    std_logic_vector (20 downto 1);  -- Added 19 and 20 to this
      qdr_bw_n             : out    std_logic_vector (1 downto 0);
      qdr_clk_k            : out    std_logic;
      qdr_clk_k_bar        : out    std_logic;
      qdr_read_b           : out    std_logic;
      qdr_write_b          : out    std_logic;
      readout_sync_trig_o  : out    std_logic;
      reset_o              : out    std_logic;
      sinkdata_fe0_o       : out    std_logic_vector (31 downto 0);
      t1                   : out    std_logic_vector (31 downto 0);
      t2                   : out    std_logic_vector (31 downto 0);
      test_point           : out    std_logic_vector (5 downto 1);
      trig_be_o            : out    std_logic;
      trig_into_fe0_en_o   : out    std_logic;
      trig_ser_out         : out    std_logic;
      vme_command_out      : out    std_logic;
      wr_data_qdr1_lsb     : out    std_logic_vector (17 downto 0);
      wr_data_qdr2_msb     : out    std_logic_vector (17 downto 0);  -- 18-bit LSB data to be written to QDR 1.
      lm82_sda             : inout  std_logic
   );

-- Declarations

end top_level ;

-- hds interface_end
-- RAL. / UCL / Man  
-- CALICE Readout Card                  
-- (based on CMS FED Front End Driver)  
--
-- VHDL Architecture back_end_fpga.top_level.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:07:50 06/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;

library CERC_lib;
library back_end_fpga;
library unisim;

architecture struct of top_level is

   -- Architecture declarations

   -- Internal signal declarations
   signal APV_frame               : std_logic;
   signal APV_frame1              : std_logic;
   signal FE_enable_reg           : std_logic_vector(8 downto 1);
   signal FE_frame_sync_en        : std_logic_vector(8 downto 1);
   signal FE_reset                : std_logic;
   signal FE_trigger              : std_logic;
   signal L1A_bx_25_flag          : std_logic;
   signal L1A_bx_50_flag          : std_logic;
   signal L1A_bx_87_flag          : std_logic;
   signal L1A_bx_count_data       : std_logic_vector(35 downto 0);
   signal L1A_bx_fifo_empty       : std_logic;
   signal L1A_bx_fifo_full        : std_logic;
   signal L1A_count               : std_logic_vector(23 downto 0);
   signal Q                       : std_logic_vector(24 downto 0);
   signal TTC_reset               : std_logic;
   signal ana_dat                 : std_logic;
   signal apv_frame_en            : std_logic;
   signal back_pressure_B         : std_logic;
   signal be_status_reg           : std_logic_vector(31 downto 0);
   signal bx_count                : std_logic_vector(11 downto 0);
   signal clk1x                   : std_logic;
   signal clk1x_n                 : STD_ULOGIC;
   signal clk2x                   : std_logic;
   signal clk2x_n                 : STD_ULOGIC;
   signal config_in               : std_logic_vector(8 downto 1);
   signal config_out              : std_logic_vector(8 downto 1);
   signal din                     : std_logic_vector(24 downto 0);
   signal empty_flags             : std_logic_vector(7 downto 0);
   signal empty_flags00           : std_logic_vector(7 downto 0);
   signal en_fe_data_capture      : std_logic;
   signal en_qdr_data_to_slink    : std_logic;
   signal en_qdr_data_to_vme      : std_logic;
   signal en_trigger              : std_logic;
   signal fast_rdout_sync_en_i    : std_logic;
   signal fast_rdout_sync_en_o    : std_logic;
   signal fe_frame_sync_in        : std_logic_vector(8 downto 1);
   signal fe_monitor_out          : std_logic_vector(8 downto 1);
   signal fed_id_reg              : std_logic_vector(11 downto 0);
   signal fifo_reset              : std_logic;
   signal frame_sync_in           : std_logic_vector(8 downto 1);
   signal frame_sync_out          : std_logic_vector(8 downto 1);
   signal frame_sync_test_data    : std_logic_vector(79 downto 0);
   signal full_flags              : std_logic_vector(7 downto 0);
   signal full_flags00            : std_logic_vector(7 downto 0);
   signal half_full_flags         : std_logic_vector(7 downto 0);
   signal half_full_flags00       : std_logic_vector(7 downto 0);
   signal high                    : std_logic;
   signal internal_freeze_bar     : std_logic;
   signal internal_freeze_high    : std_logic;
   signal load                    : std_logic;
   signal locked_all_clks         : std_logic;
   signal low                     : std_logic;
   signal max                     : std_logic;
   signal moddata80_fe0           : std_logic_vector(7 downto 0);
   signal moddata_a               : std_logic_vector(7 downto 0);
   signal moddata_b               : std_logic_vector(7 downto 0);
   signal moddata_fe0             : std_logic_vector(15 downto 0);
   signal mode_reg                : std_logic_vector(3 downto 0);
   signal monitor_in              : std_logic_vector(8 downto 1);
   signal monitor_out             : std_logic_vector(8 downto 1);
   signal partial_empty_flags     : std_logic_vector(7 downto 0);
   signal partial_empty_flags00   : std_logic_vector(7 downto 0);
   signal partial_full_flags      : std_logic_vector(7 downto 0);
   signal partial_full_flags00    : std_logic_vector(7 downto 0);
   signal qdr_data_count          : std_logic_vector(19 downto 0);
   signal qdr_frame_count         : std_logic_vector(23 downto 0);
   signal qdr_test_data_en        : std_logic_vector(1 downto 0);
   signal rd_total_length_fifo_en : std_logic;
   signal readout_sync_in         : std_logic_vector(8 downto 1);
   signal readout_sync_out        : std_logic_vector(8 downto 1);
   signal reset                   : std_logic;
   signal reset_1                 : std_logic;
   signal reset_2                 : std_logic;
   signal reset_3                 : std_logic;
   signal sel_trig_source         : std_logic_vector(2 downto 0);
   signal set_freeze_high         : std_logic;
   signal set_freeze_low          : std_logic;
   signal sw_reset                : std_logic;
   signal sw_trigger              : std_logic;
   signal test_be_readout_len     : std_logic_vector(14 downto 0);
   signal test_frame_done         : std_logic;
   signal test_frame_sync         : std_logic;
   signal test_readout_len_data   : std_logic_vector(14 downto 0);
   signal test_readout_sync       : std_logic;
   signal testmode_en             : std_logic;
   signal throttle_en             : std_logic;
   signal total_frame_count       : std_logic_vector(23 downto 0);
   signal trig_into_fe0_en_i      : std_logic;
   signal ttc_broadcast_command   : std_logic_vector(12 downto 0);
   signal ttc_single_command      : std_logic_vector(38 downto 0);
   signal up_dn                   : std_logic;
   signal vme_link_clk            : std_logic;
   signal vme_link_clk_n          : std_logic;

   -- Implicit buffer signal declarations
   signal trig_into_fe0_en_o_internal : std_logic;


   -- Component Declarations
   component APV_frame_gen
   port (
      clk       : in     std_logic ;
      en        : in     std_logic ;
      rst       : in     std_logic ;
      APV_frame : out    std_logic ;
      ana_dat   : out    std_logic 
   );
   end component;
   component FDC
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component FDCP
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component INV
   port (
      I : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;
   component OR8
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      I2 : in     STD_ULOGIC;
      I3 : in     STD_ULOGIC;
      I4 : in     STD_ULOGIC;
      I5 : in     STD_ULOGIC;
      I6 : in     STD_ULOGIC;
      I7 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component TTC_block
   port (
      clk1x                   : in     std_logic ;
      clk2x                   : in     std_logic ;
      en_trigger              : in     std_logic ;
      internal_freeze_bar     : in     std_logic ;
      rd_total_length_fifo_en : in     std_logic ;
      reset                   : in     std_logic ;
      sel_trig_source         : in     std_logic_vector (2 downto 0);
      test_trig               : in     std_logic ;
      test_trig_B             : in     std_logic ;
      trigger_i               : in     std_logic ;
      FE_trigger              : out    std_logic ;
      L1A_bx_25_flag          : out    std_logic ;
      L1A_bx_50_flag          : out    std_logic ;
      L1A_bx_87_flag          : out    std_logic ;
      L1A_bx_count_data       : out    std_logic_vector (35 downto 0);
      L1A_bx_fifo_empty       : out    std_logic ;
      L1A_bx_fifo_full        : out    std_logic ;
      L1A_count               : out    std_logic_vector (23 downto 0);
      TTC_reset               : out    std_logic ;
      bx_count                : out    std_logic_vector (11 downto 0);
      ttc_broadcast_command   : out    std_logic_vector (12 downto 0);
      ttc_single_command      : out    std_logic_vector (38 downto 0)
   );
   end component;
   component clk_generation
   port (
      clk_lvds_vme      : in     std_logic ;
      clk_lvds_vme_b    : in     std_logic ;
      rst               : in     std_logic ;
      sw_reset          : in     std_logic ;
      FE_lvds_clk       : out    std_logic_vector (8 downto 1);
      FE_lvds_clk_B     : out    std_logic_vector (8 downto 1);
      FE_reset          : out    std_logic ;
      clk1x             : out    std_logic ;
      clk1x_n           : out    STD_ULOGIC ;
      clk2x             : out    std_logic ;
      clk2x_n           : out    STD_ULOGIC ;
      ext_qdr_clk_c     : out    std_logic ;
      ext_qdr_clk_c_bar : out    std_logic ;
      locked_all_clks   : out    std_logic ;
      qdr_clk_k         : out    std_logic ;
      qdr_clk_k_bar     : out    std_logic ;
      reset             : out    std_logic ;
      vme_link_clk      : out    std_logic ;
      vme_link_clk_n    : out    std_logic 
   );
   end component;
   component comments
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_dff8
   port (
      D  : in     std_logic_vector (7 downto 0);
      c  : in     std_logic ;
      r  : in     std_logic ;
      Q  : out    std_logic_vector (7 downto 0);
      Qn : out    std_logic_vector (7 downto 0)
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component qdr_slink_interface
   port (
      FE_enable_reg           : in     std_logic_vector (8 downto 1);
      FE_frame_sync_en        : in     std_logic_vector (8 downto 1);
      FE_trigger              : in     std_logic ;
      L1A_bx_count_data       : in     std_logic_vector (35 downto 0);
      back_pressure_B         : in     std_logic ;
      be_status_reg           : in     std_logic_vector (31 downto 0);
      clk1x                   : in     std_logic ;
      clk2x                   : in     std_logic ;
      clk2x_n                 : in     STD_ULOGIC ;
      en_fe_data_capture      : in     std_logic ;
      en_qdr_data_to_vme      : in     std_logic ;
      fast_rdout_sync_en_i    : in     std_logic ;
      fed_id_reg              : in     std_logic_vector (11 downto 0);
      fifo_reset              : in     std_logic ;
      frame_sync_in           : in     std_logic_vector (8 downto 1);
      frame_sync_trig_i       : in     std_logic ;
      internal_freeze_bar     : in     std_logic ;
      locked_all_clks         : in     std_logic ;
      mod1_data               : in     std_logic_vector (3 downto 0);
      mod2_data               : in     std_logic_vector (3 downto 0);
      mod3_data               : in     std_logic_vector (3 downto 0);
      mod4_data               : in     std_logic_vector (3 downto 0);
      mod5_data               : in     std_logic_vector (3 downto 0);
      mod6_data               : in     std_logic_vector (3 downto 0);
      mod7_data               : in     std_logic_vector (3 downto 0);
      mod8_data               : in     std_logic_vector (3 downto 0);
      mode_reg                : in     std_logic_vector (3 downto 0);
      qdr_1_q                 : in     std_logic_vector (17 downto 0);
      qdr_2_q                 : in     std_logic_vector (17 downto 0);
      qdr_test_data_en        : in     std_logic_vector (1 downto 0);
      readout_sync_in         : in     std_logic_vector (8 downto 1);
      readout_sync_trig_i     : in     std_logic ;
      reset                   : in     std_logic ;
      trig_data1              : in     std_logic_vector (7 downto 0);
      trig_into_fe0_en_i      : in     std_logic ;
      vme_link_clk            : in     std_logic ;
      vme_link_clk_n          : in     std_logic ;
      cntl_to_vme             : out    std_logic ;
      data_out_to_vme         : out    std_logic_vector (31 downto 0);
      data_to_vme_valid       : out    std_logic ;
      empty_flags00           : out    std_logic_vector (7 downto 0);
      full_flags00            : out    std_logic_vector (7 downto 0);
      half_full_flags00       : out    std_logic_vector (7 downto 0);
      moddata80_fe0           : out    std_logic_vector (7 downto 0);
      partial_empty_flags00   : out    std_logic_vector (7 downto 0);
      partial_full_flags00    : out    std_logic_vector (7 downto 0);
      qdr_addr                : out    std_logic_vector (20 downto 1);
      qdr_bw_n                : out    std_logic_vector (1 downto 0);
      qdr_data_count          : out    std_logic_vector (19 downto 0);
      qdr_frame_count         : out    std_logic_vector (23 downto 0);
      qdr_read_b              : out    std_logic ;
      qdr_write_b             : out    std_logic ;
      rd_total_length_fifo_en : out    std_logic ;
      readout_sync_out        : out    std_logic_vector (8 downto 1);
      readout_sync_trig_o     : out    std_logic ;
      total_frame_count       : out    std_logic_vector (23 downto 0);
      wr_data_qdr1_lsb        : out    std_logic_vector (17 downto 0);
      wr_data_qdr2_msb        : out    std_logic_vector (17 downto 0)
   );
   end component;
   component serialiser
   generic (
      WIDTH : integer := 8
   );
   port (
      rst     : in     std_logic ;
      clk     : in     std_logic ;
      en_i    : in     std_logic ;
      start_i : in     std_logic ;
      ser_o   : out    std_logic ;
      done_o  : out    std_logic ;
      data_i  : in     std_logic_vector ((WIDTH-1) downto 0)
   );
   end component;
   component vme_cntrl_status
   port (
      L1A_count             : in     std_logic_vector (23 downto 0);
      bx_count              : in     std_logic_vector (11 downto 0);
      clk1x                 : in     std_logic ;
      clk2x                 : in     std_logic ;
      config_in             : in     std_logic_vector (8 downto 1);
      empty_flags           : in     std_logic_vector (7 downto 0);
      full_flags            : in     std_logic_vector (7 downto 0);
      half_full_flags       : in     std_logic_vector (7 downto 0);
      internal_freeze_bar   : in     std_logic ;
      local_vme_read        : in     std_logic ;
      local_vme_write       : in     std_logic ;
      partial_empty_flags   : in     std_logic_vector (7 downto 0);
      partial_full_flags    : in     std_logic_vector (7 downto 0);
      qdr_data_count        : in     std_logic_vector (19 downto 0);
      qdr_frame_count       : in     std_logic_vector (23 downto 0);
      reset                 : in     std_logic ;
      rst                   : in     std_logic ;
      temp_int_b            : in     std_logic ;
      total_frame_count     : in     std_logic_vector (23 downto 0);
      trig_ser_in           : in     std_logic ;
      ttc_broadcast_command : in     std_logic_vector (12 downto 0);
      ttc_single_command    : in     std_logic_vector (38 downto 0);
      vme_command_in        : in     std_logic ;
      vme_spare_in          : in     std_logic_vector (5 downto 1);
      vme_throttle          : in     std_logic ;
      FE_enable_reg         : out    std_logic_vector (8 downto 1);
      FE_frame_sync_en      : out    std_logic_vector (8 downto 1);
      apv_frame_en          : out    std_logic ;
      back_pressure_B       : out    std_logic ;
      be_status_reg         : out    std_logic_vector (31 downto 0);
      config_out            : out    std_logic_vector (8 downto 1);
      crate_trig_in_en_o    : out    std_logic ;
      crate_trig_loop_en_o  : out    std_logic ;
      en_fe_data_capture    : out    std_logic ;
      en_qdr_data_to_slink  : out    std_logic ;
      en_qdr_data_to_vme    : out    std_logic ;
      en_trigger            : out    std_logic ;
      fast_rdout_sync_en_o  : out    std_logic ;
      fe_trig_en_o          : out    std_logic_vector (7 downto 0);
      fed_id_reg            : out    std_logic_vector (11 downto 0);
      fifo_reset            : out    std_logic ;
      lm82_scl              : out    std_logic ;
      mode_reg              : out    std_logic_vector (3 downto 0);
      qdr_test_data_en      : out    std_logic_vector (1 downto 0);
      sel_trig_source       : out    std_logic_vector (2 downto 0);
      sw_reset              : out    std_logic ;
      sw_trigger            : out    std_logic ;
      test_be_readout_len   : out    std_logic_vector (14 downto 0);
      throttle_en           : out    std_logic ;
      trig_into_fe0_en_o    : out    std_logic ;
      trig_ser_out          : out    std_logic ;
      vme_command_out       : out    std_logic ;
      lm82_sda              : inout  std_logic 
   );
   end component;

   -- ModuleWare Component Declarations
   component cntr_88E9AFC7
   port (
      clk   : in     std_logic;
      din   : in     std_logic_vector (24 downto 0);
      load  : in     std_logic;
      reset : in     std_logic;
      up_dn : in     std_logic;
      count : out    std_logic_vector (24 downto 0);
      max   : out    std_logic
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : APV_frame_gen use entity back_end_fpga.APV_frame_gen(fsm);
   for all : FDC use entity unisim.FDC;
   for all : FDCP use entity unisim.FDCP;
   for all : INV use entity unisim.INV;
   for all : OR8 use entity unisim.OR8;
   for all : TTC_block use entity back_end_fpga.TTC_block(struct);
   for all : clk_generation use entity back_end_fpga.clk_generation(struct);
   for all : comments use entity back_end_fpga.comments(struct);
   for all : m_buff use entity CERC_lib.m_buff(rtl);
   for all : m_dff8 use entity CERC_lib.m_dff8(rtl);
   for all : m_or2 use entity CERC_lib.m_or2(rtl);
   for all : qdr_slink_interface use entity back_end_fpga.qdr_slink_interface(struct);
   for all : serialiser use entity CERC_lib.serialiser(rtl);
   for all : vme_cntrl_status use entity back_end_fpga.vme_cntrl_status(struct);
   -- exemplar synthesis_on

   -- ModuleWare embedded configurations
   -- exemplar synthesis_off
   for all : cntr_88E9AFC7 use entity back_end_fpga.cntr_88E9AFC7;
   -- exemplar synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   fe_readout_sync_in <= readout_sync_out;
   
   fe_config_in    <= config_out;
   fe_monitor_in   <= monitor_out; -- used for fe reset
   
   readout_sync_in <= fe_readout_sync_out when (testmode_en = '0')       else
                         "11111111"       when (test_readout_sync = '1') else
                         "00000000";
   
   frame_sync_in   <= fe_frame_sync_out   when (testmode_en = '0')       else
                         "11111111"       when (test_frame_sync = '1')   else
                         "00000000";
   
   config_in       <= fe_config_out;     -- fe vme serial comms
   
   
   -- test taps for 'event sink fifo'
   sinkdata_fe0_o(31 downto 21) <= (others => '0');  
   sinkdata_fe0_o(20) <=  trigger_raw_i;
   sinkdata_fe0_o(19) <=  trigger_i;
   sinkdata_fe0_o(18) <=  readout_sync_out(1);
   sinkdata_fe0_o(17) <=  frame_sync_in(1);
   sinkdata_fe0_o(16) <=  readout_sync_in(1);
   sinkdata_fe0_o(15 downto 0) <= moddata_fe0;
   
   -- Obsolete in CERC:
   --fe_frame_sync_in   <= frame_sync_out; -- used by trig lines
   --monitor_in         <= fe_monitor_out; -- used by diff (inv) trig now

   -- HDL Embedded Text Block 2 eb3
   test_point <= FE_trigger & vme_throttle & throttle_en & back_pressure_B
   & APV_frame;       -- do not remove APV_frame

   -- HDL Embedded Text Block 4 eb4
   din <= (others => '0');
   load <= '0';
   up_dn <= '1';

   -- HDL Embedded Text Block 5 eb5
   BE_LED <= Q(24);
   led_run_process <= en_fe_data_capture ;

   -- HDL Embedded Text Block 6 eb6
   t1(31) <= en_qdr_data_to_vme;         -- be_rdout_cntl(1)
   t1(30) <= en_qdr_data_to_slink;       -- be_rdout_cntl(0)
   t1(29) <= sw_trigger;
   t1(28 downto 25) <= mode_reg;         -- mode reg (3:0)
   t1(24) <= en_fe_data_capture;         -- be_run_cntl(1)
   t1(23) <= en_trigger;                 -- be_run_cntl(0)
   t1(22 downto 21) <= qdr_test_data_en; -- test reg (3:2)
   t1(20) <= throttle_en;                -- test reg (1)
   t1(19) <= apv_frame_en;               -- test reg (0)
   t1(18 downto 16) <= sel_trig_source;  -- trigger select
   t1(15 downto 8) <= FE_enable_reg;     -- fe disable reg
   t1(7 downto 0) <= FE_frame_sync_en;   -- fe frame sync enable reg
   
   t2(31 downto 12) <= "00000000000000000000";
   t2(11 downto 0) <= fed_id_reg;

   -- HDL Embedded Text Block 7 eb7
   --empty_flags         <= ("0" & (not fe_empty_flag) & "0" & L1A_bx_fifo_empty & "0000") or empty_flags00;
   partial_empty_flags <= ("0" & "0"                 & "0" & L1A_bx_25_flag    & "0000") or partial_empty_flags00;
   half_full_flags     <= ("0" & "0"                 & "0" & L1A_bx_50_flag    & "0000") or half_full_flags00;
   --partial_full_flags  <= ("0" & (not fe_half_flag)  & "0" & L1A_bx_87_flag    & "0000") or partial_full_flags00;
   --full_flags          <= ("0" & (not fe_full_flag)  & "0" & L1A_bx_fifo_full  & "0000") or full_flags00;
   
   empty_flags         <= ("000" & L1A_bx_fifo_empty & "0000") or empty_flags00;
   partial_full_flags  <= ("000" & L1A_bx_87_flag    & "0000") or partial_full_flags00;
   full_flags          <= ("000" & L1A_bx_fifo_full  & "0000") or full_flags00;


   -- ModuleWare code for instance 'I17' of 'gnd'

   -- ModuleWare code for instance 'I24' of 'tribuf'
   
   I24combo: process (APV_frame1, ana_dat)
   begin
      if (ana_dat = '1') then
         APV_frame <= 'Z';
      elsif (ana_dat = '0') then
         APV_frame <= APV_frame1;
      else
         APV_frame <= 'X';
      end if;
   end process I24combo;

   -- ModuleWare code for instance 'I27' of 'merge8'
   monitor_out <= FE_reset & FE_reset & FE_reset & FE_reset & FE_reset & FE_reset & FE_reset & FE_reset;

   -- ModuleWare code for instance 'I19' of 'buff'
   clk1x_o <= clk1x;

   -- ModuleWare code for instance 'I32' of 'buff'
   trig_be_o <= sw_trigger;

   -- ModuleWare code for instance 'I16' of 'vdd'
      high <= '1';

   -- ModuleWare code for instance 'I14' of 'constval'
      frame_sync_test_data <= "00000000000000000000000000000000000000000000000001111111111111111111111111111111";

   -- ModuleWare code for instance 'I34' of 'merge'
   moddata_fe0 <= moddata_b & moddata_a;

   -- ModuleWare code for instance 'I31' of 'buff'
   clk2x_o <= clk2x;

   -- ModuleWare code for instance 'I36' of 'buff'
   be_locked_all_clks_o <= locked_all_clks;

   -- ModuleWare code for instance 'I38' of 'buff'
   reset_o <= reset;
   -- Instance port mappings.
   I23 : APV_frame_gen
      port map (
         clk       => clk1x,
         en        => apv_frame_en,
         rst       => reset,
         APV_frame => APV_frame1,
         ana_dat   => ana_dat
      );
   I29 : FDCP
      port map (
         Q   => internal_freeze_high,
         C   => low,
         CLR => set_freeze_high,
         D   => low,
         PRE => set_freeze_low
      );
   I11 : FDCP
      port map (
         Q   => reset_1,
         C   => clk1x,
         CLR => low,
         D   => reset,
         PRE => reset
      );
   I15 : FDCP
      port map (
         Q   => reset_2,
         C   => clk1x,
         CLR => low,
         D   => reset_1,
         PRE => reset
      );
   I20 : FDCP
      port map (
         Q   => reset_3,
         C   => clk1x,
         CLR => low,
         D   => reset_2,
         PRE => reset
      );
   I28 : FDCP
      port map (
         Q   => set_freeze_high,
         C   => clk1x,
         CLR => low,
         D   => reset_3,
         PRE => reset
      );
   I30 : INV
      port map (
         O => internal_freeze_bar,
         I => internal_freeze_high
      );
   I26 : OR8
      port map (
         O  => set_freeze_low,
         I0 => full_flags(0),
         I1 => full_flags(1),
         I2 => full_flags(2),
         I3 => full_flags(3),
         I4 => full_flags(4),
         I5 => full_flags(5),
         I6 => full_flags(6),
         I7 => full_flags(7)
      );
   TTC_block_1 : TTC_block
      port map (
         clk1x                   => clk1x,
         clk2x                   => clk2x,
         en_trigger              => en_trigger,
         internal_freeze_bar     => internal_freeze_bar,
         rd_total_length_fifo_en => rd_total_length_fifo_en,
         reset                   => reset,
         sel_trig_source         => sel_trig_source,
         test_trig               => test_trig,
         test_trig_B             => test_trig_B,
         trigger_i               => trigger_i,
         FE_trigger              => FE_trigger,
         L1A_bx_25_flag          => L1A_bx_25_flag,
         L1A_bx_50_flag          => L1A_bx_50_flag,
         L1A_bx_87_flag          => L1A_bx_87_flag,
         L1A_bx_count_data       => L1A_bx_count_data,
         L1A_bx_fifo_empty       => L1A_bx_fifo_empty,
         L1A_bx_fifo_full        => L1A_bx_fifo_full,
         L1A_count               => L1A_count,
         TTC_reset               => TTC_reset,
         bx_count                => bx_count,
         ttc_broadcast_command   => ttc_broadcast_command,
         ttc_single_command      => ttc_single_command
      );
   clk_generation_1 : clk_generation
      port map (
         clk_lvds_vme      => clk_lvds_vme,
         clk_lvds_vme_b    => clk_lvds_vme_b,
         rst               => rst,
         sw_reset          => sw_reset,
         FE_lvds_clk       => FE_lvds_clk,
         FE_lvds_clk_B     => FE_lvds_clk_B,
         FE_reset          => FE_reset,
         clk1x             => clk1x,
         clk1x_n           => clk1x_n,
         clk2x             => clk2x,
         clk2x_n           => clk2x_n,
         ext_qdr_clk_c     => ext_qdr_clk_c,
         ext_qdr_clk_c_bar => ext_qdr_clk_c_bar,
         locked_all_clks   => locked_all_clks,
         qdr_clk_k         => qdr_clk_k,
         qdr_clk_k_bar     => qdr_clk_k_bar,
         reset             => reset,
         vme_link_clk      => vme_link_clk,
         vme_link_clk_n    => vme_link_clk_n
      );
   I21 : comments;
   I37 : m_buff
      port map (
         I => fast_rdout_sync_en_o,
         O => fast_rdout_sync_en_i
      );
   I35 : m_buff
      port map (
         I => trig_into_fe0_en_o_internal,
         O => trig_into_fe0_en_i
      );
   I25 : m_dff8
      port map (
         D  => moddata80_fe0,
         c  => clk1x,
         r  => rst,
         Q  => moddata_a,
         Qn => open
      );
   I33 : m_dff8
      port map (
         D  => moddata80_fe0,
         c  => clk1x_n,
         r  => rst,
         Q  => moddata_b,
         Qn => open
      );
   I22 : m_or2
      port map (
         I1 => qdr_test_data_en(1),
         I2 => qdr_test_data_en(0),
         O  => testmode_en
      );
   qdr_slink_interface_1 : qdr_slink_interface
      port map (
         FE_enable_reg           => FE_enable_reg,
         FE_frame_sync_en        => FE_frame_sync_en,
         FE_trigger              => FE_trigger,
         L1A_bx_count_data       => L1A_bx_count_data,
         back_pressure_B         => back_pressure_B,
         be_status_reg           => be_status_reg,
         clk1x                   => clk1x,
         clk2x                   => clk2x,
         clk2x_n                 => clk2x_n,
         en_fe_data_capture      => en_fe_data_capture,
         en_qdr_data_to_vme      => en_qdr_data_to_vme,
         fast_rdout_sync_en_i    => fast_rdout_sync_en_i,
         fed_id_reg              => fed_id_reg,
         fifo_reset              => fifo_reset,
         frame_sync_in           => frame_sync_in,
         frame_sync_trig_i       => frame_sync_trig_i,
         internal_freeze_bar     => internal_freeze_bar,
         locked_all_clks         => locked_all_clks,
         mod1_data               => mod1_data,
         mod2_data               => mod2_data,
         mod3_data               => mod3_data,
         mod4_data               => mod4_data,
         mod5_data               => mod5_data,
         mod6_data               => mod6_data,
         mod7_data               => mod7_data,
         mod8_data               => mod8_data,
         mode_reg                => mode_reg,
         qdr_1_q                 => qdr_1_q,
         qdr_2_q                 => qdr_2_q,
         qdr_test_data_en        => qdr_test_data_en,
         readout_sync_in         => readout_sync_in,
         readout_sync_trig_i     => readout_sync_trig_i,
         reset                   => reset,
         trig_data1              => trig_data1,
         trig_into_fe0_en_i      => trig_into_fe0_en_i,
         vme_link_clk            => vme_link_clk,
         vme_link_clk_n          => vme_link_clk_n,
         cntl_to_vme             => cntl_to_vme,
         data_out_to_vme         => data_out_to_vme,
         data_to_vme_valid       => data_to_vme_valid,
         empty_flags00           => empty_flags00,
         full_flags00            => full_flags00,
         half_full_flags00       => half_full_flags00,
         moddata80_fe0           => moddata80_fe0,
         partial_empty_flags00   => partial_empty_flags00,
         partial_full_flags00    => partial_full_flags00,
         qdr_addr                => qdr_addr,
         qdr_bw_n                => qdr_bw_n,
         qdr_data_count          => qdr_data_count,
         qdr_frame_count         => qdr_frame_count,
         qdr_read_b              => qdr_read_b,
         qdr_write_b             => qdr_write_b,
         rd_total_length_fifo_en => rd_total_length_fifo_en,
         readout_sync_out        => readout_sync_out,
         readout_sync_trig_o     => readout_sync_trig_o,
         total_frame_count       => total_frame_count,
         wr_data_qdr1_lsb        => wr_data_qdr1_lsb,
         wr_data_qdr2_msb        => wr_data_qdr2_msb
      );
   serialiser_2 : serialiser
      generic map (
         WIDTH => 80
      )
      port map (
         rst     => rst,
         clk     => clk1x,
         en_i    => high,
         start_i => FE_trigger,
         ser_o   => test_frame_sync,
         done_o  => test_frame_done,
         data_i  => frame_sync_test_data
      );
   serialiser_1 : serialiser
      generic map (
         WIDTH => 15
      )
      port map (
         rst     => rst,
         clk     => clk1x,
         en_i    => high,
         start_i => test_frame_done,
         ser_o   => test_readout_sync,
         done_o  => open,
         data_i  => test_readout_len_data
      );
   vme_cntrl_status_1 : vme_cntrl_status
      port map (
         L1A_count             => L1A_count,
         bx_count              => bx_count,
         clk1x                 => clk1x,
         clk2x                 => clk2x,
         config_in             => config_in,
         empty_flags           => empty_flags,
         full_flags            => full_flags,
         half_full_flags       => half_full_flags,
         internal_freeze_bar   => internal_freeze_bar,
         local_vme_read        => local_vme_read,
         local_vme_write       => local_vme_write,
         partial_empty_flags   => partial_empty_flags,
         partial_full_flags    => partial_full_flags,
         qdr_data_count        => qdr_data_count,
         qdr_frame_count       => qdr_frame_count,
         reset                 => reset,
         rst                   => rst,
         temp_int_b            => temp_int_b,
         total_frame_count     => total_frame_count,
         trig_ser_in           => trig_ser_in,
         ttc_broadcast_command => ttc_broadcast_command,
         ttc_single_command    => ttc_single_command,
         vme_command_in        => vme_command_in,
         vme_spare_in          => vme_spare_in,
         vme_throttle          => vme_throttle,
         FE_enable_reg         => FE_enable_reg,
         FE_frame_sync_en      => FE_frame_sync_en,
         apv_frame_en          => apv_frame_en,
         back_pressure_B       => back_pressure_B,
         be_status_reg         => be_status_reg,
         config_out            => config_out,
         crate_trig_in_en_o    => crate_trig_in_en_o,
         crate_trig_loop_en_o  => crate_trig_loop_en_o,
         en_fe_data_capture    => en_fe_data_capture,
         en_qdr_data_to_slink  => en_qdr_data_to_slink,
         en_qdr_data_to_vme    => en_qdr_data_to_vme,
         en_trigger            => en_trigger,
         fast_rdout_sync_en_o  => fast_rdout_sync_en_o,
         fe_trig_en_o          => fe_trig_en_o,
         fed_id_reg            => fed_id_reg,
         fifo_reset            => fifo_reset,
         lm82_scl              => lm82_scl,
         mode_reg              => mode_reg,
         qdr_test_data_en      => qdr_test_data_en,
         sel_trig_source       => sel_trig_source,
         sw_reset              => sw_reset,
         sw_trigger            => sw_trigger,
         test_be_readout_len   => test_be_readout_len,
         throttle_en           => throttle_en,
         trig_into_fe0_en_o    => trig_into_fe0_en_o_internal,
         trig_ser_out          => trig_ser_out,
         vme_command_out       => vme_command_out,
         lm82_sda              => lm82_sda
      );

   -- ModuleWare instance port mappings.
   I9 : cntr_88E9AFC7
      port map (
         clk   => clk2x,
         din   => din,
         load  => load,
         reset => reset,
         up_dn => up_dn,
         count => Q,
         max   => max
      );


   g4: FOR i IN 1 TO 8 GENERATE
      I18 : FDC
         port map (
            Q   => frame_sync_out(i),
            C   => clk1x,
            CLR => reset,
            D   => FE_trigger
         );
   end generate g4;

   -- Implicit buffered output assignments
   trig_into_fe0_en_o <= trig_into_fe0_en_o_internal;

end struct;
