-- hds header_start
--
-- VHDL Entity back_end_fpga.tracker_header.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:58:36 06/07/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.ALL;

entity tracker_header is
   port( 
      FE_frame_sync_en    : in     std_logic_vector (8 downto 1);
      FE_trigger          : in     std_logic;
      be_status_reg       : in     std_logic_vector (31 downto 0);
      clk1x               : in     std_logic;
      clk2x               : in     std_logic;
      done                : in     std_logic;
      en_fe_data_capture  : in     std_logic;
      frm_sync_in         : in     std_logic_vector (8 downto 1);
      internal_freeze_bar : in     std_logic;
      mode_reg            : in     std_logic_vector (3 downto 0);
      rd_fe_lengths       : in     std_logic_vector (17 downto 0);
      read_hdr_en1        : in     std_logic;
      read_hdr_en2        : in     std_logic;
      reset               : in     std_logic;
      int_trkr_hdr        : out    std_logic_vector (63 downto 0);
      trkr_hdr_25_flag    : out    std_logic;
      trkr_hdr_50_flag    : out    std_logic;
      trkr_hdr_87_flag    : out    std_logic;
      trkr_hdr_fifo_empty : out    std_logic;
      trkr_hdr_fifo_full  : out    std_logic
   );

-- Declarations

end tracker_header ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.tracker_header.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:58:39 06/07/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.ALL;

library back_end_fpga;
library marc_calice;
library unisim;

architecture struct of tracker_header is

   -- Architecture declarations

   -- Internal signal declarations
   signal en_wr_trkr_hdr_fifo : std_logic;
   signal fr_sy_done1         : std_logic;
   signal fr_sy_done2         : std_logic;
   signal fr_sy_done3         : std_logic;
   signal fr_sy_done4         : std_logic;
   signal fr_sy_done5         : std_logic;
   signal fr_sy_done6         : std_logic;
   signal fr_sy_done7         : std_logic;
   signal fr_sy_done8         : std_logic;
   signal frame_sync_en       : std_logic;
   signal frame_sync_en_1     : std_logic;
   signal frame_sync_en_2     : std_logic;
   signal frame_sync_en_3     : std_logic;
   signal frame_sync_en_4     : std_logic;
   signal frame_sync_en_5     : std_logic;
   signal frame_sync_en_6     : std_logic;
   signal frame_sync_en_7     : std_logic;
   signal frame_sync_en_8     : std_logic;
   signal frame_sync_in_1     : std_logic;
   signal frame_sync_in_2     : std_logic;
   signal frame_sync_in_3     : std_logic;
   signal frame_sync_in_4     : std_logic;
   signal frame_sync_in_5     : std_logic;
   signal frame_sync_in_6     : std_logic;
   signal frame_sync_in_7     : std_logic;
   signal frame_sync_in_8     : std_logic;
   signal frame_sync_in_en    : std_logic;
   signal frm_sync_in_en      : std_logic;
   signal int_trkr_hdr1       : std_logic_vector(63 downto 0);
   signal rd_fe_lengths1      : std_logic_vector(15 downto 0);
   signal temp_bus            : std_logic_vector(47 downto 0);
   signal temp_trkr_hdr       : std_logic_vector(63 downto 0);
   signal tracker_hdr_1       : std_logic_vector(79 downto 0);
   signal tracker_hdr_2       : std_logic_vector(79 downto 0);
   signal tracker_hdr_3       : std_logic_vector(79 downto 0);
   signal tracker_hdr_4       : std_logic_vector(79 downto 0);
   signal tracker_hdr_5       : std_logic_vector(79 downto 0);
   signal tracker_hdr_6       : std_logic_vector(79 downto 0);
   signal tracker_hdr_7       : std_logic_vector(79 downto 0);
   signal tracker_hdr_8       : std_logic_vector(79 downto 0);
   signal tracker_header_1    : std_logic_vector(127 downto 0);
   signal tracker_header_2    : std_logic_vector(127 downto 0);
   signal tracker_header_3    : std_logic_vector(127 downto 0);
   signal tracker_header_4    : std_logic_vector(127 downto 0);
   signal tracker_header_5    : std_logic_vector(127 downto 0);
   signal tracker_header_6    : std_logic_vector(127 downto 0);
   signal tracker_header_7    : std_logic_vector(127 downto 0);
   signal tracker_header_8    : std_logic_vector(127 downto 0);
   signal trkr_hdr_fifo_flags : std_logic_vector(2 downto 0);


   -- ModuleWare signal declarations for instance 'I19' of 'split8'
   signal MW_I19dinl : std_logic_vector(7 downto 0);

   -- ModuleWare signal declarations for instance 'I21' of 'split8'
   signal MW_I21dinl : std_logic_vector(7 downto 0);

   -- Component Declarations
   component OR8
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      I2 : in     STD_ULOGIC;
      I3 : in     STD_ULOGIC;
      I4 : in     STD_ULOGIC;
      I5 : in     STD_ULOGIC;
      I6 : in     STD_ULOGIC;
      I7 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component deserialiser_80
   port (
      clk   : in     std_logic ;
      clr_Q : in     std_logic ;
      data  : in     std_logic ;
      en    : in     std_logic ;
      reset : in     std_logic ;
      Q     : out    std_logic_vector (79 downto 0);
      done  : out    std_logic 
   );
   end component;
   component length_in_header
   port (
      clk2x          : in     std_logic ;
      rd_fe_lengths1 : in     std_logic_vector (15 downto 0);
      read_hdr_en2   : in     std_logic ;
      reset          : in     std_logic ;
      temp_trkr_hdr  : in     std_logic_vector (63 downto 0);
      int_trkr_hdr1  : out    std_logic_vector (63 downto 0)
   );
   end component;
   component marc_header_tracker
   port (
      FE_trigger          : in     std_logic ;
      be_status_reg       : in     std_logic_vector (31 downto 0);
      clk1x               : in     std_logic ;
      clk2x               : in     std_logic ;
      done                : in     std_logic ;
      en_fe_data_capture  : in     std_logic ;
      frame_sync_en       : in     std_logic ;
      internal_freeze_bar : in     std_logic ;
      mode_reg            : in     std_logic_vector (3 downto 0);
      rd_fe_lengths       : in     std_logic_vector (17 downto 0);
      read_hdr_en1        : in     std_logic ;
      reset               : in     std_logic ;
      tracker_header_1    : in     std_logic_vector (127 downto 0);
      tracker_header_2    : in     std_logic_vector (127 downto 0);
      tracker_header_3    : in     std_logic_vector (127 downto 0);
      tracker_header_4    : in     std_logic_vector (127 downto 0);
      tracker_header_5    : in     std_logic_vector (127 downto 0);
      tracker_header_6    : in     std_logic_vector (127 downto 0);
      tracker_header_7    : in     std_logic_vector (127 downto 0);
      tracker_header_8    : in     std_logic_vector (127 downto 0);
      en_wr_trkr_hdr_fifo : out    std_logic ;
      rd_fe_lengths1      : out    std_logic_vector (15 downto 0);
      temp_trkr_hdr1      : out    std_logic_vector (63 downto 0);
      trkr_hdr_fifo_empty : out    std_logic ;
      trkr_hdr_fifo_flags : out    std_logic_vector (2 downto 0);
      trkr_hdr_fifo_full  : out    std_logic 
   );
   end component;
   component trkr_hdr_flag_gen
   port (
      clk2x               : in     std_logic ;
      reset               : in     std_logic ;
      trkr_hdr_fifo_flags : in     std_logic_vector (2 downto 0);
      trkr_hdr_25_flag    : out    std_logic ;
      trkr_hdr_50_flag    : out    std_logic ;
      trkr_hdr_87_flag    : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : OR8 use entity unisim.OR8;
   for all : deserialiser_80 use entity back_end_fpga.deserialiser_80(fsm);
   for all : length_in_header use entity back_end_fpga.length_in_header(fsm);
   for all : marc_header_tracker use entity marc_calice.marc_header_tracker(struct);
   for all : trkr_hdr_flag_gen use entity back_end_fpga.trkr_hdr_flag_gen(rtl);
   -- exemplar synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   temp_bus <= (others => '0');
   tracker_header_1 <=  temp_bus & (tracker_hdr_1) after 1 ns;
   tracker_header_2 <=  temp_bus & (tracker_hdr_2) after 1 ns;
   tracker_header_3 <=  temp_bus & (tracker_hdr_3) after 1 ns ;
   tracker_header_4 <=  temp_bus & (tracker_hdr_4) after 1 ns ;
   tracker_header_5 <=  temp_bus & (tracker_hdr_5) after 1 ns ;
   tracker_header_6 <=  temp_bus & (tracker_hdr_6) after 1 ns ;
   tracker_header_7 <=  temp_bus & (tracker_hdr_7) after 1 ns ;
   tracker_header_8 <=  temp_bus & (tracker_hdr_8) after 1 ns ;

   -- HDL Embedded Text Block 2 eb2
   frame_sync_in_en <= frm_sync_in_en after 1 ns;

   -- HDL Embedded Text Block 5 eb5
   int_trkr_hdr <= int_trkr_hdr1 after 1 ns;


   -- ModuleWare code for instance 'I19' of 'split8'
   MW_I19dinl <= frm_sync_in;
   
   I19combo: process (MW_I19dinl)
   variable itemp : std_logic_vector(7 downto 0);
   begin
      itemp := MW_I19dinl(7 downto 0);
      frame_sync_in_1 <= itemp(0);
      frame_sync_in_2 <= itemp(1);
      frame_sync_in_3 <= itemp(2);
      frame_sync_in_4 <= itemp(3);
      frame_sync_in_5 <= itemp(4);
      frame_sync_in_6 <= itemp(5);
      frame_sync_in_7 <= itemp(6);
      frame_sync_in_8 <= itemp(7);
   end process I19combo;

   -- ModuleWare code for instance 'I21' of 'split8'
   MW_I21dinl <= FE_frame_sync_en;
   
   I21combo: process (MW_I21dinl)
   variable itemp : std_logic_vector(7 downto 0);
   begin
      itemp := MW_I21dinl(7 downto 0);
      frame_sync_en_1 <= itemp(0);
      frame_sync_en_2 <= itemp(1);
      frame_sync_en_3 <= itemp(2);
      frame_sync_en_4 <= itemp(3);
      frame_sync_en_5 <= itemp(4);
      frame_sync_en_6 <= itemp(5);
      frame_sync_en_7 <= itemp(6);
      frame_sync_en_8 <= itemp(7);
   end process I21combo;
   -- Instance port mappings.
   I14 : OR8
      port map (
         O  => frame_sync_en,
         I0 => fr_sy_done1,
         I1 => fr_sy_done2,
         I2 => fr_sy_done3,
         I3 => fr_sy_done4,
         I4 => fr_sy_done5,
         I5 => fr_sy_done6,
         I6 => fr_sy_done7,
         I7 => fr_sy_done8
      );
   I1 : deserialiser_80
      port map (
         clk   => clk1x,
         clr_Q => en_wr_trkr_hdr_fifo,
         data  => frame_sync_in_1,
         en    => frame_sync_en_1,
         reset => reset,
         Q     => tracker_hdr_1,
         done  => fr_sy_done1
      );
   I2 : deserialiser_80
      port map (
         clk   => clk1x,
         clr_Q => en_wr_trkr_hdr_fifo,
         data  => frame_sync_in_2,
         en    => frame_sync_en_2,
         reset => reset,
         Q     => tracker_hdr_2,
         done  => fr_sy_done2
      );
   I3 : deserialiser_80
      port map (
         clk   => clk1x,
         clr_Q => en_wr_trkr_hdr_fifo,
         data  => frame_sync_in_3,
         en    => frame_sync_en_3,
         reset => reset,
         Q     => tracker_hdr_3,
         done  => fr_sy_done3
      );
   I5 : deserialiser_80
      port map (
         clk   => clk1x,
         clr_Q => en_wr_trkr_hdr_fifo,
         data  => frame_sync_in_4,
         en    => frame_sync_en_4,
         reset => reset,
         Q     => tracker_hdr_4,
         done  => fr_sy_done4
      );
   I8 : deserialiser_80
      port map (
         clk   => clk1x,
         clr_Q => en_wr_trkr_hdr_fifo,
         data  => frame_sync_in_5,
         en    => frame_sync_en_5,
         reset => reset,
         Q     => tracker_hdr_5,
         done  => fr_sy_done5
      );
   I9 : deserialiser_80
      port map (
         clk   => clk1x,
         clr_Q => en_wr_trkr_hdr_fifo,
         data  => frame_sync_in_6,
         en    => frame_sync_en_6,
         reset => reset,
         Q     => tracker_hdr_6,
         done  => fr_sy_done6
      );
   I10 : deserialiser_80
      port map (
         clk   => clk1x,
         clr_Q => en_wr_trkr_hdr_fifo,
         data  => frame_sync_in_7,
         en    => frame_sync_en_7,
         reset => reset,
         Q     => tracker_hdr_7,
         done  => fr_sy_done7
      );
   I11 : deserialiser_80
      port map (
         clk   => clk1x,
         clr_Q => en_wr_trkr_hdr_fifo,
         data  => frame_sync_in_8,
         en    => frame_sync_en_8,
         reset => reset,
         Q     => tracker_hdr_8,
         done  => fr_sy_done8
      );
   I6 : length_in_header
      port map (
         clk2x          => clk2x,
         rd_fe_lengths1 => rd_fe_lengths1,
         read_hdr_en2   => read_hdr_en2,
         reset          => reset,
         temp_trkr_hdr  => temp_trkr_hdr,
         int_trkr_hdr1  => int_trkr_hdr1
      );
   marc_header_tracker_1 : marc_header_tracker
      port map (
         FE_trigger          => FE_trigger,
         be_status_reg       => be_status_reg,
         clk1x               => clk1x,
         clk2x               => clk2x,
         done                => done,
         en_fe_data_capture  => en_fe_data_capture,
         frame_sync_en       => frame_sync_en,
         internal_freeze_bar => internal_freeze_bar,
         mode_reg            => mode_reg,
         rd_fe_lengths       => rd_fe_lengths,
         read_hdr_en1        => read_hdr_en1,
         reset               => reset,
         tracker_header_1    => tracker_header_1,
         tracker_header_2    => tracker_header_2,
         tracker_header_3    => tracker_header_3,
         tracker_header_4    => tracker_header_4,
         tracker_header_5    => tracker_header_5,
         tracker_header_6    => tracker_header_6,
         tracker_header_7    => tracker_header_7,
         tracker_header_8    => tracker_header_8,
         en_wr_trkr_hdr_fifo => en_wr_trkr_hdr_fifo,
         rd_fe_lengths1      => rd_fe_lengths1,
         temp_trkr_hdr1      => temp_trkr_hdr,
         trkr_hdr_fifo_empty => trkr_hdr_fifo_empty,
         trkr_hdr_fifo_flags => trkr_hdr_fifo_flags,
         trkr_hdr_fifo_full  => trkr_hdr_fifo_full
      );
   I0 : trkr_hdr_flag_gen
      port map (
         clk2x               => clk2x,
         reset               => reset,
         trkr_hdr_fifo_flags => trkr_hdr_fifo_flags,
         trkr_hdr_25_flag    => trkr_hdr_25_flag,
         trkr_hdr_50_flag    => trkr_hdr_50_flag,
         trkr_hdr_87_flag    => trkr_hdr_87_flag
      );

end struct;
