-- hds header_start
--
-- VHDL Entity back_end_fpga.vme_qdr_rd.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:54:39 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;

entity vme_qdr_rd is
   port( 
      clk2x              : in     std_logic;
      clk2x_n            : in     STD_ULOGIC;
      ctrl               : in     std_logic;
      data_out           : in     std_logic_vector (63 downto 0);
      data_out_en        : in     std_logic;
      en_qdr_data_to_vme : in     std_logic;
      local_reset        : in     std_logic;
      vme_link_clk       : in     std_logic;
      vme_link_clk_n     : in     std_logic;
      cntl_to_vme        : out    std_logic;
      data_out_to_vme    : out    std_logic_vector (31 downto 0);
      data_to_vme_valid  : out    std_logic
   );

-- Declarations

end vme_qdr_rd ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.vme_qdr_rd.struct_clk_inv
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:54:46 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

library unisim;

architecture struct_clk_inv of vme_qdr_rd is

   -- Architecture declarations

-- Size-specific type conversion functions
-- ren_conv_slv32 - converts STD_ULOGIC to 32-bit std_logic_vector
function ren_conv_slv32 ( val : STD_ULOGIC ) return std_logic_vector is
begin
   return conv_std_logic_vector(val, 32);
end ren_conv_slv32;

   -- Internal signal declarations
   signal data_out_lsb : std_logic_vector(31 downto 0);
   signal data_out_msb : std_logic_vector(31 downto 0);
   signal low          : STD_ULOGIC;
   signal reset        : std_logic;


   -- ModuleWare signal declarations for instance 'I10' of 'split'
   signal MW_I10dinl : std_logic_vector(63 downto 0);

   -- Component Declarations
   component FDDRCPE
   port (
      C0  : in     STD_ULOGIC;
      C1  : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D0  : in     STD_ULOGIC;
      D1  : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : FDDRCPE use entity unisim.FDDRCPE;
   -- exemplar synthesis_on


begin

   -- ModuleWare code for instance 'I10' of 'split'
   MW_I10dinl <= data_out;
   data_out_lsb <= MW_I10dinl(31 downto 0);
   data_out_msb <= MW_I10dinl(63 downto 32);

   -- ModuleWare code for instance 'I12' of 'gnd'
      low <= '0';

   -- ModuleWare code for instance 'I13' of 'buff'
   reset <= local_reset;
   -- Instance port mappings.
   I2 : FDDRCPE
      port map (
         Q   => data_to_vme_valid,
         C0  => clk2x_n,
         C1  => clk2x,
         CE  => en_qdr_data_to_vme,
         D0  => data_out_en,
         D1  => data_out_en,
         CLR => reset,
         PRE => low
      );
   I1 : FDDRCPE
      port map (
         Q   => cntl_to_vme,
         C0  => vme_link_clk_n,
         C1  => vme_link_clk,
         CE  => en_qdr_data_to_vme,
         D0  => ctrl,
         D1  => ctrl,
         CLR => reset,
         PRE => low
      );

   g2: FOR i IN 0 TO 31 GENERATE
      I3 : FDDRCPE
         port map (
            Q   => data_out_to_vme(i),
            C0  => clk2x_n,
            C1  => clk2x,
            CE  => en_qdr_data_to_vme,
            D0  => data_out_msb(i),
            D1  => data_out_lsb(i),
            CLR => reset,
            PRE => low
         );
   end generate g2;

end struct_clk_inv;
