-- hds header_start
--
-- VHDL Entity back_end_fpga.word64_lengths.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:52:01 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity word64_lengths is
   port( 
      byte_length1       : in     std_logic_vector (14 downto 0);
      byte_length2       : in     std_logic_vector (14 downto 0);
      byte_length3       : in     std_logic_vector (14 downto 0);
      byte_length4       : in     std_logic_vector (14 downto 0);
      byte_length5       : in     std_logic_vector (14 downto 0);
      byte_length6       : in     std_logic_vector (14 downto 0);
      byte_length7       : in     std_logic_vector (14 downto 0);
      byte_length8       : in     std_logic_vector (14 downto 0);
      clk1x              : in     std_logic;
      clk2x              : in     std_logic;
      done               : in     std_logic;
      en_fe_data_capture : in     std_logic;
      rd_trckr_hdr_en    : in     std_logic;
      reset              : in     std_logic;
      rst_registers      : in     std_logic;
      done_1             : out    std_logic;
      fe_len_25_flag     : out    std_logic;
      fe_len_50_flag     : out    std_logic;
      fe_len_87_flag     : out    std_logic;
      fe_len_empty       : out    std_logic;
      fe_len_full        : out    std_logic;
      length1            : out    std_logic_vector (17 downto 0);
      length2            : out    std_logic_vector (17 downto 0);
      length3            : out    std_logic_vector (17 downto 0);
      length4            : out    std_logic_vector (17 downto 0);
      length5            : out    std_logic_vector (17 downto 0);
      length6            : out    std_logic_vector (17 downto 0);
      length7            : out    std_logic_vector (17 downto 0);
      length8            : out    std_logic_vector (17 downto 0);
      rd_fe_lengths      : out    std_logic_vector (17 downto 0)
   );

-- Declarations

end word64_lengths ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.word64_lengths.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:52:02 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.ALL;

library back_end_fpga;
library marc_calice;

architecture struct of word64_lengths is

   -- Architecture declarations

   -- Internal signal declarations
   signal rd_fe_len_flags  : std_logic_vector(2 downto 0);
   signal wr_fe_lenghts_en : std_logic;
   signal wr_fe_lengths    : std_logic_vector(17 downto 0);


   -- Component Declarations
   component fifo_replacement_16k_18bit
   port (
      ainit    : in     std_logic ;
      din      : in     std_logic_vector (17 downto 0);
      rd_clk   : in     std_logic ;
      rd_en    : in     std_logic ;
      wr_clk   : in     std_logic ;
      wr_en    : in     std_logic ;
      dout     : out    std_logic_vector (17 downto 0);
      empty    : out    std_logic ;
      full     : out    std_logic ;
      wr_count : out    std_logic_vector (2 downto 0)
   );
   end component;
   component length_decrement
   generic (
      denom : integer := 8
   );
   port (
      d_length : in     std_logic_vector (14 downto 0); -- number of data byte
      a_length : out    std_logic_vector (17 downto 0); -- number of 64-bit words of data
      clk      : in     std_logic ;
      en       : in     std_logic ;
      reset    : in     std_logic 
   );
   end component;
   component rd_fe_len_flag_gen
   port (
      clk2x           : in     std_logic ;
      rd_fe_len_flags : in     std_logic_vector (2 downto 0);
      reset           : in     std_logic ;
      fe_len_25_flag  : out    std_logic ;
      fe_len_50_flag  : out    std_logic ;
      fe_len_87_flag  : out    std_logic 
   );
   end component;
   component wr_all_lengths
   port (
      byte_length1       : in     std_logic_vector (14 downto 0);
      byte_length2       : in     std_logic_vector (14 downto 0);
      byte_length3       : in     std_logic_vector (14 downto 0);
      byte_length4       : in     std_logic_vector (14 downto 0);
      byte_length5       : in     std_logic_vector (14 downto 0);
      byte_length6       : in     std_logic_vector (14 downto 0);
      byte_length7       : in     std_logic_vector (14 downto 0);
      byte_length8       : in     std_logic_vector (14 downto 0);
      clk1x              : in     std_logic ;
      done               : in     std_logic ;
      en_fe_data_capture : in     std_logic ;
      reset              : in     std_logic ;
      wr_fe_lenghts_en   : out    std_logic ;
      wr_fe_lengths      : out    std_logic_vector (17 downto 0)
   );
   end component;

   -- ModuleWare Component Declarations
   component adff_614B7010
   port (
      Clk : in     std_logic;
      D   : in     std_logic;
      Rst : in     std_logic;
      Q   : out    std_logic;
      Qb  : out    std_logic
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : fifo_replacement_16k_18bit use entity marc_calice.fifo_replacement_16k_18bit(struct);
   for all : length_decrement use entity back_end_fpga.length_decrement(rtl);
   for all : rd_fe_len_flag_gen use entity back_end_fpga.rd_fe_len_flag_gen(rtl);
   for all : wr_all_lengths use entity back_end_fpga.wr_all_lengths(fsm);
   -- exemplar synthesis_on

   -- ModuleWare embedded configurations
   -- exemplar synthesis_off
   for all : adff_614B7010 use entity back_end_fpga.adff_614B7010;
   -- exemplar synthesis_on


begin
   -- Instance port mappings.
   I12 : fifo_replacement_16k_18bit
      port map (
         ainit    => reset,
         din      => wr_fe_lengths,
         rd_clk   => clk1x,
         rd_en    => rd_trckr_hdr_en,
         wr_clk   => clk1x,
         wr_en    => wr_fe_lenghts_en,
         dout     => rd_fe_lengths,
         empty    => fe_len_empty,
         full     => fe_len_full,
         wr_count => rd_fe_len_flags
      );
   I7 : length_decrement
      generic map (
         denom => 8
      )
      port map (
         d_length => byte_length8,
         a_length => length8,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I1 : length_decrement
      generic map (
         denom => 8
      )
      port map (
         d_length => byte_length2,
         a_length => length2,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I3 : length_decrement
      generic map (
         denom => 8
      )
      port map (
         d_length => byte_length4,
         a_length => length4,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I5 : length_decrement
      generic map (
         denom => 8
      )
      port map (
         d_length => byte_length6,
         a_length => length6,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I0 : length_decrement
      generic map (
         denom => 8
      )
      port map (
         d_length => byte_length1,
         a_length => length1,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I6 : length_decrement
      generic map (
         denom => 8
      )
      port map (
         d_length => byte_length7,
         a_length => length7,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I4 : length_decrement
      generic map (
         denom => 8
      )
      port map (
         d_length => byte_length5,
         a_length => length5,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I2 : length_decrement
      generic map (
         denom => 8
      )
      port map (
         d_length => byte_length3,
         a_length => length3,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I8 : rd_fe_len_flag_gen
      port map (
         clk2x           => clk2x,
         rd_fe_len_flags => rd_fe_len_flags,
         reset           => reset,
         fe_len_25_flag  => fe_len_25_flag,
         fe_len_50_flag  => fe_len_50_flag,
         fe_len_87_flag  => fe_len_87_flag
      );
   I10 : wr_all_lengths
      port map (
         byte_length1       => byte_length1,
         byte_length2       => byte_length2,
         byte_length3       => byte_length3,
         byte_length4       => byte_length4,
         byte_length5       => byte_length5,
         byte_length6       => byte_length6,
         byte_length7       => byte_length7,
         byte_length8       => byte_length8,
         clk1x              => clk1x,
         done               => done,
         en_fe_data_capture => en_fe_data_capture,
         reset              => reset,
         wr_fe_lenghts_en   => wr_fe_lenghts_en,
         wr_fe_lengths      => wr_fe_lengths
      );

   -- ModuleWare instance port mappings.
   I9 : adff_614B7010
      port map (
         Clk => clk1x,
         D   => done,
         Rst => reset,
         Q   => done_1,
         Qb  => open
      );


end struct;
