-- hds header_start
--
-- VHDL Entity back_end_fpga.wr_addr_to_fifo.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:52:12 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.ALL;

entity wr_addr_to_fifo is
   port( 
      addr_bases        : in     std_logic_vector (159 downto 0);
      clk1x             : in     std_logic;
      done_2            : in     std_logic;
      frame_lengths     : in     std_logic_vector (143 downto 0);
      reset             : in     std_logic;
      wr_base           : out    std_logic_vector (19 downto 0);
      wr_base_length_en : out    std_logic;
      wr_length         : out    std_logic_vector (17 downto 0)
   );

-- Declarations

end wr_addr_to_fifo ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.wr_addr_to_fifo.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:52:12 06/01/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of wr_addr_to_fifo is

   -- Architecture Declarations
   type state_type is (
      frm_wr_0,
      frm_wr_1,
      frm_wr_2,
      frm_wr_3,
      frm_wr_4,
      frm_wr_5,
      frm_wr_6,
      frm_wr_7,
      frm_wr_8,
      frm_wr_9
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal wr_base_cld : std_logic_vector (19 downto 0) ;
   signal wr_base_length_en_cld : std_logic  ;
   signal wr_length_cld : std_logic_vector (17 downto 0) ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk1x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= frm_wr_0;
         -- Reset Values
         wr_base_cld <= (others =>'0');
         wr_base_length_en_cld <= '0';
         wr_length_cld <= (others =>'0');
      elsif (clk1x'event and clk1x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         wr_base_cld <= (others =>'0');
         wr_base_length_en_cld <= '0';
         wr_length_cld <= (others =>'0');

         -- Combined Actions for internal signals only
         case current_state is
         when frm_wr_0 =>
            wr_base_length_en_cld <= '0' after 1 ns;
             wr_base_cld <= (others => '0')  after 1 ns;
            wr_length_cld <= (others => '0')  after 1 ns;
         when frm_wr_1 =>
            wr_base_cld <= addr_bases ( 19 downto 0) after 1 ns;
            wr_length_cld <= frame_lengths ( 17 downto 0) after 1 ns;
            wr_base_length_en_cld <= '1'  after 1 ns;
         when frm_wr_2 =>
            wr_base_cld <= addr_bases ( 39 downto 20) after 1 ns;
            wr_length_cld <= frame_lengths ( 35 downto 18) after 1 ns;
            wr_base_length_en_cld <= '1'  after 1 ns;
         when frm_wr_3 =>
            wr_base_cld <= addr_bases ( 59 downto 40) after 1 ns;
            wr_length_cld <= frame_lengths ( 53 downto 36) after 1 ns;
            wr_base_length_en_cld <= '1'  after 1 ns;
         when frm_wr_4 =>
            wr_base_cld <= addr_bases ( 79 downto 60) after 1 ns;
            wr_length_cld <= frame_lengths ( 71 downto 54) after 1 ns;
            wr_base_length_en_cld <= '1'  after 1 ns;
         when frm_wr_5 =>
            wr_base_cld <= addr_bases ( 99 downto 80) after 1 ns;
            wr_length_cld <= frame_lengths ( 89 downto 72) after 1 ns;
            wr_base_length_en_cld <= '1'  after 1 ns;
         when frm_wr_6 =>
            wr_base_cld <= addr_bases ( 119 downto 100) after 1 ns;
            wr_length_cld <= frame_lengths ( 107 downto 90) after 1 ns;
            wr_base_length_en_cld <= '1'  after 1 ns;
         when frm_wr_7 =>
            wr_base_cld <= addr_bases ( 139 downto 120) after 1 ns;
            wr_length_cld <= frame_lengths ( 125 downto 108) after 1 ns;
            wr_base_length_en_cld <= '1'  after 1 ns;
         when frm_wr_8 =>
            wr_base_cld <= addr_bases ( 159 downto 140) after 1 ns;
            wr_length_cld <= frame_lengths ( 143 downto 126) after 1 ns;
            wr_base_length_en_cld <= '1'  after 1 ns;
         when frm_wr_9 =>
            wr_base_length_en_cld <= '0'  after 1 ns;
             wr_base_cld <= (others => '0')  after 1 ns;
            wr_length_cld <= (others => '0')  after 1 ns;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      current_state,
      done_2
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when frm_wr_0 =>
         if (done_2 = '1') then
            next_state <= frm_wr_1;
         else
            next_state <= frm_wr_0;
         end if;
      when frm_wr_1 =>
            next_state <= frm_wr_2;
      when frm_wr_2 =>
            next_state <= frm_wr_3;
      when frm_wr_3 =>
            next_state <= frm_wr_4;
      when frm_wr_4 =>
            next_state <= frm_wr_5;
      when frm_wr_5 =>
            next_state <= frm_wr_6;
      when frm_wr_6 =>
            next_state <= frm_wr_7;
      when frm_wr_7 =>
            next_state <= frm_wr_8;
      when frm_wr_8 =>
            next_state <= frm_wr_9;
      when frm_wr_9 =>
            next_state <= frm_wr_0;
      when others =>
         next_state <= frm_wr_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   wr_base <= wr_base_cld;
   wr_base_length_en <= wr_base_length_en_cld;
   wr_length <= wr_length_cld;


end fsm;
