-- hds header_start
--
-- VHDL Entity back_end_fpga.wr_burst_2.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:06:10 06/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity wr_burst_2 is
   port( 
      D0         : in     std_logic;
      D1         : in     std_logic;
      DCM_locked : in     std_ulogic;
      clk        : in     std_logic;
      rst        : in     std_logic;
      wr         : in     std_logic;
      Q          : out    std_logic
   );

-- Declarations

end wr_burst_2 ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.wr_burst_2.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:06:20 06/09/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

library unisim;

architecture struct of wr_burst_2 is

   -- Architecture declarations

   -- Internal signal declarations
   signal D1_fdc  : std_logic;
   signal ENVOI_1 : STD_ULOGIC;
   signal Q1      : STD_ULOGIC;
   signal ce_fddr : std_logic;
   signal clk_b_1 : std_logic;
   signal clk_b_2 : std_logic;
   signal high    : std_ulogic := '0';
   signal low     : std_ulogic;
   signal q2      : std_logic;
   signal q3      : std_logic;


   -- ModuleWare signal declarations for instance 'I0' of 'dff'
   signal MW_I0cregl : std_logic;

   -- ModuleWare signal declarations for instance 'I8' of 'dff'
   signal MW_I8cregl : std_logic;

   -- Component Declarations
   component fdc_1
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component fddrcpe
   port (
      C0  : in     STD_ULOGIC;
      C1  : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D0  : in     STD_ULOGIC;
      D1  : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component inv
   port (
      I : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;
   component obuft_hstl_i
   port (
      I : in     STD_ULOGIC;
      T : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;

   -- Optional embedded configurations
   -- exemplar synthesis_off
   for all : fdc_1 use entity unisim.fdc_1;
   for all : fddrcpe use entity unisim.fddrcpe;
   for all : inv use entity unisim.inv;
   for all : obuft_hstl_i use entity unisim.obuft_hstl_i;
   -- exemplar synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   ce_fddr <= wr AND DCM_locked after 1 ns;
   low <= '0';
   high <= '1';


   -- ModuleWare code for instance 'I2' of 'or2'
      ENVOI_1 <= q2 or q3;

   -- ModuleWare code for instance 'I0' of 'dff'
   q2 <= MW_I0cregl;
   -- synopsys sync_set_reset_local of I0seq "rst"
   I0seq: process (clk)
   begin
      if (clk'event and clk='1') then
            if (rst = '1') then
               MW_I0cregl <= '1';
            else
               MW_I0cregl <= wr;
            end if;
      end if;
   end process I0seq;

   -- ModuleWare code for instance 'I8' of 'dff'
   q3 <= MW_I8cregl;
   -- synopsys async_set_reset_local of I8seq "rst"
   I8seq: process (clk_b_2, rst)
   begin
      if (rst = '1') then
         MW_I8cregl <= '1';
      elsif (clk_b_2'event and clk_b_2='1') then
         MW_I8cregl <= wr;
      end if;
   end process I8seq;
   -- Instance port mappings.
   I3 : fdc_1
      port map (
         Q   => D1_fdc,
         C   => clk,
         CLR => rst,
         D   => D1
      );
   I1 : fddrcpe
      port map (
         Q   => Q1,
         C0  => clk_b_1,
         C1  => clk,
         CE  => high,
         D0  => D0,
         D1  => D1_fdc,
         CLR => rst,
         PRE => low
      );
   I5 : inv
      port map (
         O => clk_b_1,
         I => clk
      );
   I7 : inv
      port map (
         O => clk_b_2,
         I => clk
      );
   I4 : obuft_hstl_i
      port map (
         O => Q,
         I => Q1,
         T => low
      );

end struct;
